## glibc 2.35-0ubuntu3.10+11.0trisquel1

=== Makefile ===
# Copyright (C) 1991-2022 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Master Makefile for the GNU C library
#
ifneq (,)
This makefile requires GNU Make.
endif

include Makeconfig


# This is the default target; it makes everything except the tests.
.PHONY: all help minihelp
all: minihelp lib others

help:
	@sed '0,/^help-starts-here$$/d' Makefile.help

minihelp:
	@echo
	@echo type \"make help\" for help with common glibc makefile targets
	@echo


ifneq ($(AUTOCONF),no)

define autoconf-it
@-rm -f $@.new
$(AUTOCONF) $(ACFLAGS) $< > $@.new
chmod a-w$(patsubst %,$(comma)a+x,$(filter .,$(@D))) $@.new
mv -f $@.new $@
endef

configure: configure.ac aclocal.m4; $(autoconf-it)
%/configure: %/configure.ac aclocal.m4; $(autoconf-it)
%/preconfigure: %/preconfigure.ac aclocal.m4; $(autoconf-it)

endif # $(AUTOCONF) = no


# We don't want to run anything here in parallel.
.NOTPARALLEL:

# These are the targets that are made by making them in each subdirectory.
+subdir_targets	:= subdir_lib objects objs others subdir_mostlyclean	\
		   subdir_clean subdir_distclean subdir_realclean	\
		   tests xtests						\
		   subdir_update-abi subdir_check-abi			\
		   subdir_update-all-abi				\
		   subdir_echo-headers					\
		   subdir_install					\
		   subdir_objs subdir_stubs subdir_testclean		\
		   $(addprefix install-, no-libc.a bin lib data headers others)

headers := limits.h values.h features.h features-time64.h gnu-versions.h \
	   bits/xopen_lim.h gnu/libc-version.h stdc-predef.h \
	   bits/libc-header-start.h

echo-headers: subdir_echo-headers

# The headers are in the include directory.
subdir-dirs = include
vpath %.h $(subdir-dirs)

# What to install.
install-others = $(inst_includedir)/gnu/stubs.h
install-bin-script =

ifeq (yes,$(build-shared))
headers += gnu/lib-names.h
endif

include Makerules

ifeq ($(build-programs),yes)
others: $(addprefix $(objpfx),$(install-bin-script))
endif

# Install from subdirectories too.
install: subdir_install

# Explicit dependency so that `make install-headers' works
install-headers: install-headers-nosubdir

# Make sure that the dynamic linker is installed before libc.
$(inst_slibdir)/libc-$(version).so: elf/ldso_install

.PHONY: elf/ldso_install
elf/ldso_install:
	$(MAKE) -C $(@D) $(@F)

# Create links for shared libraries using the `ldconfig' program if possible.
# Ignore the error if we cannot update /etc/ld.so.cache.
ifeq (no,$(cross-compiling))
ifeq (yes,$(build-shared))
install:
	-test ! -x $(elf-objpfx)ldconfig || LC_ALL=C \
	  $(elf-objpfx)ldconfig $(addprefix -r ,$(install_root)) \
				$(slibdir) $(libdir)
ifneq (no,$(PERL))
ifeq (/usr,$(prefix))
ifeq (,$(install_root))
	LD_SO=$(ld.so-version) CC="$(CC)" $(PERL) scripts/test-installation.pl $(common-objpfx)
endif
endif
endif
endif
endif

# Build subdirectory lib objects.
lib-noranlib: subdir_lib

ifeq (yes,$(build-shared))
# Build the shared object from the PIC object library.
lib: $(common-objpfx)libc.so $(common-objpfx)linkobj/libc.so
endif # $(build-shared)

# Used to build testrun.sh.
define testrun-script
#!/bin/bash
builddir=`dirname "$$0"`
GCONV_PATH="$${builddir}/iconvdata"

usage () {
cat << EOF
Usage: $$0 [OPTIONS] <program> [ARGUMENTS...]

  --tool=TOOL  Run with the specified TOOL. It can be strace, rpctrace,
               valgrind or container. The container will run within
               support/test-container.
EOF

  exit 1
}

toolname=default
while test $$# -gt 0 ; do
  case "$$1" in
    --tool=*)
      toolname="$${1:7}"
      shift
      ;;
    --*)
      usage
      ;;
    *)
      break
      ;;
  esac
done

if test $$# -eq 0 ; then
  usage
fi

case "$$toolname" in
  default)
    exec $(subst $(common-objdir),"$${builddir}", $(test-program-prefix)) \
      $${1+"$$@"}
    ;;
  strace)
    exec strace $(patsubst %, -E%, $(run-program-env)) \
      $(test-via-rtld-prefix) $${1+"$$@"}
    ;;
  rpctrace)
    exec rpctrace $(patsubst %, -E%, $(run-program-env)) \
      $(test-via-rtld-prefix) $${1+"$$@"}
    ;;
  valgrind)
    exec env $(run-program-env) valgrind $(test-via-rtld-prefix) $${1+"$$@"}
    ;;
  container)
    exec env $(run-program-env) $(test-via-rtld-prefix) \
      $(common-objdir)/support/test-container \
      env $(run-program-env) $(test-via-rtld-prefix) $${1+"$$@"}
    ;;
  *)
    usage
    ;;
esac
endef

# This is a handy script for running any dynamically linked program against
# the current libc build for testing.
$(common-objpfx)testrun.sh: $(common-objpfx)config.make \
			    $(..)Makeconfig $(..)Makefile
	$(file >$@T,$(testrun-script))
	chmod a+x $@T
	mv -f $@T $@
postclean-generated += testrun.sh

define debugglibc
#!/bin/bash

SOURCE_DIR="$(CURDIR)"
BUILD_DIR="$(common-objpfx)"
CMD_FILE="$(common-objpfx)debugglibc.gdb"
CONTAINER=false
DIRECT=true
STATIC=false
SYMBOLSFILE=true
unset TESTCASE
unset BREAKPOINTS
unset ENVVARS

usage()
{
cat << EOF
Usage: $$0 [OPTIONS] <program>

   Or: $$0 [OPTIONS] -- <program> [<args>]...

  where <program> is the path to the program being tested,
  and <args> are the arguments to be passed to it.

Options:

  -h, --help
	Prints this message and leaves.

  The following options require one argument:

  -b, --breakpoint
	Breakpoints to set at the beginning of the execution
	(each breakpoint demands its own -b option, e.g. -b foo -b bar)
  -e, --environment-variable
	Environment variables to be set with 'exec-wrapper env' in GDB
	(each environment variable demands its own -e option, e.g.
	-e FOO=foo -e BAR=bar)

  The following options do not take arguments:

  -c, --in-container
	Run the test case inside a container and automatically attach
	GDB to it.
  -i, --no-direct
	Selects whether to pass the --direct flag to the program.
	--direct is useful when debugging glibc test cases. It inhibits the
	tests from forking and executing in a subprocess.
	Default behaviour is to pass the --direct flag, except when the
	program is run with user specified arguments using the "--" separator.
  -s, --no-symbols-file
	Do not tell GDB to load debug symbols from the program.
EOF
}

# Parse input options
while [[ $$# > 0 ]]
do
  key="$$1"
  case $$key in
    -h|--help)
      usage
      exit 0
      ;;
    -b|--breakpoint)
      BREAKPOINTS="break $$2\n$$BREAKPOINTS"
      shift
      ;;
    -e|--environment-variable)
      ENVVARS="$$2 $$ENVVARS"
      shift
      ;;
    -c|--in-container)
      CONTAINER=true
      ;;
    -i|--no-direct)
      DIRECT=false
      ;;
    -s|--no-symbols-file)
      SYMBOLSFILE=false
      ;;
    --)
      shift
      TESTCASE=$$1
      COMMANDLINE="$$@"
      # Don't add --direct when user specifies program arguments
      DIRECT=false
      break
      ;;
    *)
      TESTCASE=$$1
      COMMANDLINE=$$TESTCASE
      ;;
  esac
  shift
done

# Check for required argument and if the testcase exists
if [ ! -v TESTCASE ] || [ ! -f $${TESTCASE} ]
then
  usage
  exit 1
fi

# Container tests needing locale data should install them in-container.
# Other tests/binaries need to use locale data from the build tree.
if [ "$$CONTAINER" = false ]
then
  ENVVARS="GCONV_PATH=$${BUILD_DIR}/iconvdata $$ENVVARS"
  ENVVARS="LOCPATH=$${BUILD_DIR}/localedata $$ENVVARS"
  ENVVARS="LC_ALL=C $$ENVVARS"
fi

# Expand environment setup command
if [ -v ENVVARS ]
then
  ENVVARSCMD="set exec-wrapper env $$ENVVARS"
fi

# Expand direct argument
if [ "$$DIRECT" == true ]
then
  DIRECT="--direct"
else
  DIRECT=""
fi

# Check if the test case is static
if file $${TESTCASE} | grep "statically linked" >/dev/null
then
  STATIC=true
else
  STATIC=false
fi

# Expand symbols loading command
if [ "$$SYMBOLSFILE" == true ]
then
  SYMBOLSFILE="add-symbol-file $${TESTCASE}"
else
  SYMBOLSFILE=""
fi

# GDB commands template
template ()
{
cat <<EOF
set environment C -E -x c-header
set auto-load safe-path $${BUILD_DIR}/nptl_db:\$$debugdir:\$$datadir/auto-load
set libthread-db-search-path $${BUILD_DIR}/nptl_db
__ENVVARS__
__SYMBOLSFILE__
break _dl_start_user
run --library-path $(rpath-link):$${BUILD_DIR}/nptl_db \
__COMMANDLINE__ __DIRECT__
__BREAKPOINTS__
EOF
}

# Generate the commands file for gdb initialization
template | sed \
  -e "s|__ENVVARS__|$$ENVVARSCMD|" \
  -e "s|__SYMBOLSFILE__|$$SYMBOLSFILE|" \
  -e "s|__COMMANDLINE__|$$COMMANDLINE|" \
  -e "s|__DIRECT__|$$DIRECT|" \
  -e "s|__BREAKPOINTS__|$$BREAKPOINTS|" \
  > $$CMD_FILE

echo
echo "Debugging glibc..."
echo "Build directory  : $$BUILD_DIR"
echo "Source directory : $$SOURCE_DIR"
echo "GLIBC Testcase   : $$TESTCASE"
echo "GDB Commands     : $$CMD_FILE"
echo "Env vars         : $$ENVVARS"
echo

if [ "$$CONTAINER" == true ]
then
# Use testrun.sh to start the test case with WAIT_FOR_DEBUGGER=1, then
# automatically attach GDB to it.
WAIT_FOR_DEBUGGER=1 $(common-objpfx)testrun.sh --tool=container $${TESTCASE} &
gdb -x $${TESTCASE}.gdb
elif [ "$$STATIC" == true ]
then
gdb $${TESTCASE}
else
# Start the test case debugging in two steps:
#   1. the following command invokes gdb to run the loader;
#   2. the commands file tells the loader to run the test case.
gdb -q \
  -x $${CMD_FILE} \
  -d $${SOURCE_DIR} \
  $${BUILD_DIR}/elf/ld.so
fi
endef

# This is another handy script for debugging dynamically linked program
# against the current libc build for testing.
$(common-objpfx)debugglibc.sh: $(common-objpfx)config.make \
			    $(..)Makeconfig $(..)Makefile
	$(file >$@T,$(debugglibc))
	chmod a+x $@T
	mv -f $@T $@
postclean-generated += debugglibc.sh debugglibc.gdb

others: $(common-objpfx)testrun.sh $(common-objpfx)debugglibc.sh

# Makerules creates a file `stubs' in each subdirectory, which
# contains `#define __stub_FUNCTION' for each function defined in that
# directory which is a stub.
# Here we paste all of these together into <gnu/stubs.h>.

subdir-stubs := $(foreach dir,$(subdirs),$(common-objpfx)$(dir)/stubs)

ifndef abi-variants
installed-stubs = $(inst_includedir)/gnu/stubs.h
else
installed-stubs = $(inst_includedir)/gnu/stubs-$(default-abi).h

$(inst_includedir)/gnu/stubs.h: $(+force)
	$(make-target-directory)
	{ \
	 echo '/* This file is automatically generated.';\
	 echo "   This file selects the right generated file of \`__stub_FUNCTION' macros";\
	 echo '   based on the architecture being compiled for.  */'; \
	 echo ''; \
	 $(foreach h,$(abi-includes), echo '#include <$(h)>';) \
	 echo ''; \
	 $(foreach v,$(abi-variants),\
	 $(if $(abi-$(v)-condition),\
	 echo '#if $(abi-$(v)-condition)'; \
	 echo '# include <gnu/stubs-$(v).h>'); \
	 $(if $(abi-$(v)-condition),echo '#endif';) \
	 rm -f $(@:.d=.h).new$(v); \
	 ) \
	} > $(@:.d=.h).new
	mv -f $(@:.d=.h).new $(@:.d=.h)

install-others-nosubdir: $(installed-stubs)
endif

# If we're bootstrapping, install a dummy gnu/stubs.h along with the
# other headers, so 'make install-headers' produces a useable include
# tree.  Otherwise, install gnu/stubs.h later, after the rest of the
# build is done.
ifeq ($(install-bootstrap-headers),yes)
install-headers: $(inst_includedir)/gnu/stubs.h $(installed-stubs) \
		 $(inst_includedir)/$(lib-names-h-abi)
endif

# Since stubs.h is never needed when building the library, we simplify the
# hairy installation process by producing it in place only as the last part
# of the top-level `make install'.  It depends on subdir_install, which

=== catgets/Makefile ===
# Copyright (C) 1996-2022 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Makefile for catgets.
#
subdir	:= catgets

include ../Makeconfig

headers		= nl_types.h
routines	= catgets open_catalog
others		= gencat
install-bin	= gencat
extra-objs	= $(gencat-modules:=.o)

tests = tst-catgets
test-srcs = test-gencat

ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)de/libc.cat $(objpfx)test1.cat $(objpfx)test2.cat \
		 $(objpfx)sample.SJIS.cat $(objpfx)test-gencat.out
tests-special += $(objpfx)tst-catgets-mem.out
endif

gencat-modules	= xmalloc
others-extras   = $(gencat-modules)

# To find xmalloc.c
vpath %.c ../locale/programs


include ../Rules

$(objpfx)gencat: $(gencat-modules:%=$(objpfx)%.o)

catgets-CPPFLAGS := -DNLSPATH='"$(localedir)/%L/%N:$(localedir)/%L/LC_MESSAGES/%N:$(localedir)/%l/%N:$(localedir)/%l/LC_MESSAGES/%N:"'

generated += de.msg test1.cat test1.h test2.cat test2.h sample.SJIS.cat \
	     test-gencat.h
generated += tst-catgets.mtrace tst-catgets-mem.out

generated-dirs += de

tst-catgets-ENV = NLSPATH="$(objpfx)%l/%N.cat" LANG=de \
		  MALLOC_TRACE=$(objpfx)tst-catgets.mtrace \
		  LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so

ifeq ($(run-built-tests),yes)
# This test just checks whether the program produces any error or not.
# The result is not tested.
$(objpfx)test1.cat: test1.msg $(objpfx)gencat
	$(built-program-cmd-before-env) \
	$(run-program-env) LC_ALL=hr_HR.ISO-8859-2 \
	$(built-program-cmd-after-env) -H $(objpfx)test1.h $@ $<; \
	$(evaluate-test)
$(objpfx)test2.cat: test2.msg $(objpfx)gencat
	$(built-program-cmd) -H $(objpfx)test2.h $@ $<; \
	$(evaluate-test)
$(objpfx)de/libc.cat: $(objpfx)de.msg $(objpfx)gencat
	$(make-target-directory)
	$(built-program-cmd-before-env) \
	$(run-program-env) LC_ALL=de_DE.ISO-8859-1 \
	$(built-program-cmd-after-env) $@ $<; \
	$(evaluate-test)
$(objpfx)tst-catgets.out: $(objpfx)de/libc.cat

# Generate a non-simple input file.
$(objpfx)de.msg: xopen-msg.awk $(..)po/de.po
	LC_ALL=C $(AWK) -f $^ $< > $@

$(objpfx)test-gencat.out: test-gencat.sh $(objpfx)test-gencat \
			  $(objpfx)sample.SJIS.cat
	$(SHELL) $< $(common-objpfx) '$(test-program-cmd-before-env)' \
		 '$(run-program-env)' '$(test-program-cmd-after-env)'; \
	$(evaluate-test)

$(objpfx)sample.SJIS.cat: sample.SJIS $(objpfx)gencat
	$(built-program-cmd) -H $(objpfx)test-gencat.h < $(word 1,$^) > $@; \
	$(evaluate-test)

$(objpfx)tst-catgets-mem.out: $(objpfx)tst-catgets.out
	$(common-objpfx)malloc/mtrace $(objpfx)tst-catgets.mtrace > $@; \
	$(evaluate-test)
endif

=== elf/Makefile ===
# Copyright (C) 1995-2022 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

# Makefile for elf subdirectory of GNU C Library.

subdir		:= elf

include ../Makeconfig

headers = \
  bits/elfclass.h \
  bits/link.h \
  bits/link_lavcurrent.h \
  elf.h \
  link.h \
  # headers

routines = \
  $(all-dl-routines) \
  dl-addr \
  dl-addr-obj \
  dl-error \
  dl-iteratephdr \
  dl-libc \
  dl-origin \
  dl-profstub \
  dl-reloc-static-pie \
  dl-support \
  dl-sym \
  dl-sysdep \
  enbl-secure \
  libc-dl_find_object \
  libc_early_init \
  rtld_static_init \
  # routines

# The core dynamic linking functions are in libc for the static and
# profiled libraries.
dl-routines = \
  dl-call-libc-early-init \
  dl-close \
  dl-debug \
  dl-debug-symbols \
  dl-deps \
  dl-exception \
  dl-execstack \
  dl-find_object \
  dl-fini \
  dl-init \
  dl-load \
  dl-lookup \
  dl-lookup-direct \
  dl-minimal-malloc \
  dl-misc \
  dl-object \
  dl-open \
  dl-origin \
  dl-printf \
  dl-profile \
  dl-reloc \
  dl-runtime \
  dl-scope \
  dl-setup_hash \
  dl-sort-maps \
  dl-thread_gscope_wait \
  dl-tls \
  dl-tls_init_tp \
  dl-trampoline \
  dl-version \
  dl-write \
  # dl-routines

ifeq (yes,$(use-ldconfig))
dl-routines += dl-cache
endif

ifneq (no,$(have-tunables))
dl-routines += dl-tunables
tunables-type = $(addprefix TUNABLES_FRONTEND_,$(have-tunables))
CPPFLAGS-dl-tunables.c += -DTUNABLES_FRONTEND=$(tunables-type)

ifeq (yesyes,$(build-shared)$(run-built-tests))
tests-special += $(objpfx)list-tunables.out
endif

# Make sure that the compiler does not insert any library calls in tunables
# code paths.
ifeq (yes,$(have-loop-to-function))
CFLAGS-dl-tunables.c += -fno-tree-loop-distribute-patterns
endif
endif

all-dl-routines = $(dl-routines) $(sysdep-dl-routines)
# But they are absent from the shared libc, because that code is in ld.so.
elide-routines.os = \
  $(all-dl-routines) \
  dl-exception \
  dl-origin \
  dl-reloc-static-pie \
  dl-support \
  dl-sysdep \
  enbl-secure \
  rtld_static_init \
  thread_gscope_wait \
  # elide-routines.os

# These object files are only included in the dynamically-linked libc.
shared-only-routines = libc-dl_find_object

# ld.so uses those routines, plus some special stuff for being the program
# interpreter and operating independent of libc.
rtld-routines = \
  $(all-dl-routines) \
  dl-audit \
  dl-compat \
  dl-conflict \
  dl-diagnostics \
  dl-diagnostics-cpu \
  dl-diagnostics-kernel \
  dl-environ \
  dl-error-minimal \
  dl-hwcaps \
  dl-hwcaps-subdirs \
  dl-hwcaps_split \
  dl-libc_freeres \
  dl-minimal \
  dl-mutex \
  dl-sysdep \
  dl-usage \
  rtld \
  # rtld-routines

all-rtld-routines = $(rtld-routines) $(sysdep-rtld-routines)

CFLAGS-dl-runtime.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-dl-lookup.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-dl-iteratephdr.c += $(uses-callbacks)

# Called during static library initialization, so turn stack-protection
# off for non-shared builds.
CFLAGS-dl-minimal-malloc.o = $(no-stack-protector)
CFLAGS-dl-minimal-malloc.op = $(no-stack-protector)

# On targets without __builtin_memset, rtld.c uses a hand-coded loop
# in _dl_start.  Make sure this isn't turned into a call to regular memset.
ifeq (yes,$(have-loop-to-function))
CFLAGS-rtld.c += -fno-tree-loop-distribute-patterns
endif

# Compile rtld itself without stack protection.
# Also compile all routines in the static library that are elided from
# the shared libc because they are in libc.a in the same way.

CFLAGS-.o += $(call elide-stack-protector,.o,$(elide-routines.os))
CFLAGS-.op += $(call elide-stack-protector,.op,$(elide-routines.os))
CFLAGS-.os += $(call elide-stack-protector,.os,$(all-rtld-routines))

# Add the requested compiler flags to the early startup code.
CFLAGS-dl-printf.os += $(rtld-early-cflags)
CFLAGS-dl-setup_hash.os += $(rtld-early-cflags)
CFLAGS-dl-sysdep.os += $(rtld-early-cflags)
CFLAGS-dl-tunables.os += $(rtld-early-cflags)
CFLAGS-dl-write.os += $(rtld-early-cflags)
CFLAGS-dl-writev.os += $(rtld-early-cflags)
CFLAGS-rtld.os += $(rtld-early-cflags)

ifeq ($(unwind-find-fde),yes)
routines += unwind-dw2-fde-glibc
shared-only-routines += unwind-dw2-fde-glibc
endif

before-compile  += $(objpfx)trusted-dirs.h
generated	+= trusted-dirs.h trusted-dirs.st for-renamed/renamed.so
generated-dirs	+= for-renamed

ifeq ($(build-shared),yes)
ld-map		= $(common-objpfx)ld.map
endif

ifeq (yes,$(build-shared))
extra-objs = \
  $(all-rtld-routines:%=%.os) \
  sofini.os \
  interp.os \
  # extra-objs
generated += \
  dl-allobjs.os \
  ld.so ldd \
  librtld.os \
  # generated
install-others	= $(inst_rtlddir)/$(rtld-installed-name) $(inst_bindir)/ld.so
install-bin-script = ldd
endif

others		= sprof sln
install-bin	= sprof
others-static   = sln
install-rootsbin = sln
sln-modules	:= static-stubs
extra-objs	+= $(sln-modules:=.o)

ifeq (yes,$(use-ldconfig))
ifeq (yes,$(build-shared))
others-static	+= ldconfig
others		+= ldconfig
install-rootsbin += ldconfig

ldconfig-modules := \
  cache \
  chroot_canon \
  readlib \
  static-stubs \
  stringtable \
  xmalloc \
  xstrdup \
  # ldconfig-modules
extra-objs	+= $(ldconfig-modules:=.o)
others-extras   = $(ldconfig-modules)
endif
endif

# To find xmalloc.c and xstrdup.c
vpath %.c ../locale/programs

ifeq ($(build-shared),yes)
extra-objs += sotruss-lib.os sotruss-lib.so
install-others += $(inst_auditdir)/sotruss-lib.so
install-bin-script += sotruss
generated += sotruss
libof-sotruss-lib = extramodules
LDFLAGS-sotruss-lib.so += $(z-now-$(bind-now))
$(objpfx)sotruss-lib.so: $(objpfx)sotruss-lib.os
	$(build-module-asneeded)
$(objpfx)sotruss-lib.so: $(common-objpfx)libc.so $(objpfx)ld.so \
	$(common-objpfx)libc_nonshared.a

$(objpfx)sotruss: sotruss.sh $(common-objpfx)config.make
	sed -e 's%@VERSION@%$(version)%g' \
	    -e 's%@TEXTDOMAINDIR@%$(localedir)%g' \
	    -e 's%@PREFIX@%$(prefix)%g' \
	    -e 's|@PKGVERSION@|$(PKGVERSION)|g' \
	    -e 's|@REPORT_BUGS_TO@|$(REPORT_BUGS_TO)|g' \
	    < $< > $@.new
	chmod 555 $@.new
	mv -f $@.new $@
$(inst_auditdir)/sotruss-lib.so: $(objpfx)sotruss-lib.so $(+force)
	$(do-install-program)
endif

tests-static-normal := \
  tst-array1-static \
  tst-array5-static \
  tst-dl-iter-static \
  tst-dst-static \
  tst-env-setuid \
  tst-env-setuid-tunables \
  tst-getauxval-static \
  tst-linkall-static \
  tst-single_threaded-pthread-static \
  tst-single_threaded-static \
  tst-tlsalign-extern-static \
  tst-tlsalign-static \
  # tests-static-normal

tests-static-internal := \
  tst-dl_find_object-static \
  tst-ptrguard1-static \
  tst-stackguard1-static \
  tst-tls1-static \
  tst-tls1-static-non-pie \
  # tests-static-internal

CRT-tst-tls1-static-non-pie := $(csu-objpfx)crt1.o
tst-tls1-static-non-pie-no-pie = yes

tests-container := \
  tst-ldconfig-bad-aux-cache \
  tst-ldconfig-ld_so_conf-update \
  # tests-container

ifeq (no,$(build-hardcoded-path-in-tests))
# This is an ld.so.cache test, and RPATH/RUNPATH in the executable
# interferes with its test objectives.
tests-container += tst-glibc-hwcaps-prepend-cache
endif

tests := \
  tst-array1 \
  tst-array2 \
  tst-array3 \
  tst-array4 \
  tst-array5 \
  tst-auxv \
  tst-leaks1 \
  tst-stringtable \
  tst-tls9 \
  # tests

tests-internal := \
  $(tests-static-internal) \
  tst-tls1 \
  # tests-internal

tests-static := $(tests-static-normal) $(tests-static-internal)

ifeq (yes,$(build-shared))
tests-static += \
  tst-single_threaded-static-dlopen \
  tst-tls9-static \
  # tests-static

static-dlopen-environment = \
  LD_LIBRARY_PATH=$(ld-library-path):$(common-objpfx)dlfcn
tst-tls9-static-ENV = $(static-dlopen-environment)
tst-single_threaded-static-dlopen-ENV = $(static-dlopen-environment)

tests += \
  argv0test \
  constload1 \
  dblload \
  dblunload \
  filter \
  global \
  initfirst \
  lateglobal \
  loadfail \
  multiload \
  next \
  nodelete \
  nodelete2 \
  nodlopen \
  nodlopen2 \
  noload \
  order \
  order2 \
  origtest \
  preloadtest \
  reldep \
  reldep2 \
  reldep3 \
  reldep4 \
  reldep5 \
  reldep6 \
  reldep7 \
  reldep8 \
  resolvfail \
  restest1 \
  restest2 \
  tst-absolute-sym \
  tst-absolute-zero \
  tst-addr1 \
  tst-align \
  tst-align2 \
  tst-align3 \
  tst-audit1 \
  tst-audit2 \
  tst-audit8 \
  tst-audit9 \
  tst-audit11 \
  tst-audit12 \
  tst-audit13 \
  tst-audit17 \
  tst-audit18 \
  tst-audit19b \
  tst-audit20 \
  tst-audit21 \
  tst-audit22 \
  tst-audit23 \
  tst-audit24a \
  tst-audit24b \
  tst-audit24c \
  tst-audit24d \
  tst-audit25a \
  tst-audit25b \
  tst-auditmany \
  tst-auxobj \
  tst-auxobj-dlopen \
  tst-big-note \
  tst-debug1 \
  tst-deep1 \
  tst-dl-is_dso \
  tst-dlmodcount \
  tst-dlmopen1 \
  tst-dlmopen3 \
  tst-dlmopen4 \
  tst-dlmopen-dlerror \
  tst-dlmopen-gethostbyname \
  tst-dlopenfail \
  tst-dlopenfail-2 \
  tst-dlopenrpath \
  tst-dlopen-self \
  tst-dlopen-tlsmodid \
  tst-dlsym-error \
  tst-filterobj \
  tst-filterobj-dlopen \
  tst-glibc-hwcaps \
  tst-glibc-hwcaps-mask \
  tst-glibc-hwcaps-prepend \
  tst-global1 \
  tst-global2 \
  tst-initfinilazyfail \
  tst-initorder \
  tst-initorder2 \
  tst-latepthread \
  tst-main1 \
  tst-nodelete2 \
  tst-nodelete-dlclose \
  tst-nodelete-opened \
  tst-noload \
  tst-null-argv \
  tst-p_align1 \
  tst-p_align2 \
  tst-p_align3 \
  tst-relsort1 \
  tst-ro-dynamic \
  tst-rtld-run-static \
  tst-single_threaded \
  tst-single_threaded-pthread \
  tst-sonamemove-dlopen \
  tst-sonamemove-link \
  tst-thrlock \
  tst-tls10 \
  tst-tls11 \
  tst-tls12 \
  tst-tls13 \
  tst-tls14 \
  tst-tls15 \
  tst-tls16 \
  tst-tls17 \
  tst-tls18 \
  tst-tls19 \
  tst-tls20 \
  tst-tls21 \
  tst-tls4 \
  tst-tls5 \
  tst-tlsalign \
  tst-tlsalign-extern \
  tst-tls-dlinfo \
  tst-tls-ie \
  tst-tls-ie-dlmopen \
  tst-tls-manydynamic \
  tst-unique1 \
  tst-unique2 \
  tst-unwind-ctor \
  tst-unwind-main \
  unload3 \
  unload4 \
  unload5 \
  unload6 \
  unload7 \
  unload8 \
  valgrind-test \
  # tests
tests-cxx = \
  tst-dlopen-nodelete-reloc \
  tst-nodelete \
  tst-unique3 \
  tst-unique4 \
  # tests-cxx

tests += $(if $(CXX),$(tests-cxx))

tests-internal += \
  circleload1 \
  loadtest \
  neededtest \
  neededtest2 \
  neededtest3 \
  neededtest4 \
  tst-audit19a \
  tst-create_format1 \
  tst-dl-hwcaps_split \
  tst-dl_find_object \
  tst-dl_find_object-threads \
  tst-dlmopen2 \
  tst-ptrguard1 \
  tst-stackguard1 \
  tst-tls-surplus \
  tst-tls3 \
  tst-tls6 \
  tst-tls7 \
  tst-tls8 \
  unload \
  unload2 \
  # tests-internal

tests-container += \
  tst-dlopen-self-container \
  tst-dlopen-tlsmodid-container \
  tst-pldd \
  tst-preload-pthread-libc \
  # tests-container

test-srcs = \
  tst-pathopt \
  # tests-srcs

ifeq (yes,$(have-fpie))
tests-pie += tst-align3
endif
selinux-enabled := $(shell cat /selinux/enforce 2> /dev/null)

ifneq ($(selinux-enabled),1)
tests-execstack-yes = \
  tst-execstack \
  tst-execstack-needed \
  tst-execstack-prog \
  # tests-execstack-yes
endif
ifeq ($(have-depaudit),yes)
tests += \
  tst-audit14 \
  tst-audit14a \
  tst-audit15 \
  tst-audit16 \
  # tests
ifeq ($(run-built-tests),yes)
tests-special += \
  $(objpfx)tst-audit14-cmp.out \
  $(objpfx)tst-audit14a-cmp.out \
  $(objpfx)tst-audit15-cmp.out \
  $(objpfx)tst-audit16-cmp.out \
  # tests-special
endif

=== fbtl/Makefile ===
# Copyright (C) 2002-2013 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <http://www.gnu.org/licenses/>.

#
#	Sub-makefile for NPTL portion of the library.
#
subdir	:= fbtl

headers := pthread.h semaphore.h bits/semaphore.h

extra-libs := libpthread
extra-libs-others := $(extra-libs)
install-lib-ldscripts := libpthread.so

routines = alloca_cutoff forward libc-lowlevellock libc-cancellation \
	   libc-cleanup
shared-only-routines = forward

libpthread-routines = nptl-init vars events version \
		      pthread_create pthread_exit pthread_detach \
		      pthread_join pthread_tryjoin pthread_timedjoin \
		      pthread_self pthread_equal pthread_yield \
		      pthread_getconcurrency pthread_setconcurrency \
		      pthread_getschedparam pthread_setschedparam \
		      pthread_setschedprio \
		      pthread_attr_init pthread_attr_destroy \
		      pthread_attr_getdetachstate pthread_attr_setdetachstate \
		      pthread_attr_getguardsize pthread_attr_setguardsize \
		      pthread_attr_getschedparam pthread_attr_setschedparam \
		      pthread_attr_getschedpolicy pthread_attr_setschedpolicy \
		      pthread_attr_getinheritsched \
		      pthread_attr_setinheritsched \
		      pthread_attr_getscope pthread_attr_setscope \
		      pthread_attr_getstackaddr pthread_attr_setstackaddr \
		      pthread_attr_getstacksize pthread_attr_setstacksize \
		      pthread_attr_getstack pthread_attr_setstack \
		      pthread_getattr_np \
		      pthread_mutex_init pthread_mutex_destroy \
		      pthread_mutex_lock pthread_mutex_trylock \
		      pthread_mutex_timedlock pthread_mutex_unlock \
		      pthread_mutexattr_init pthread_mutexattr_destroy \
		      pthread_mutexattr_getpshared \
		      pthread_mutexattr_setpshared \
		      pthread_mutexattr_gettype pthread_mutexattr_settype \
		      pthread_rwlock_init pthread_rwlock_destroy \
		      pthread_rwlock_rdlock pthread_rwlock_timedrdlock \
		      pthread_rwlock_wrlock pthread_rwlock_timedwrlock \
		      pthread_rwlock_tryrdlock pthread_rwlock_trywrlock \
		      pthread_rwlock_unlock \
		      pthread_rwlockattr_init pthread_rwlockattr_destroy \
		      pthread_rwlockattr_getpshared \
		      pthread_rwlockattr_setpshared \
		      pthread_rwlockattr_getkind_np \
		      pthread_rwlockattr_setkind_np \
		      pthread_cond_init pthread_cond_destroy \
		      pthread_cond_wait pthread_cond_timedwait \
		      pthread_cond_signal pthread_cond_broadcast \
		      old_pthread_cond_init old_pthread_cond_destroy \
		      old_pthread_cond_wait old_pthread_cond_timedwait \
		      old_pthread_cond_signal old_pthread_cond_broadcast \
		      pthread_condattr_init pthread_condattr_destroy \
		      pthread_condattr_getpshared pthread_condattr_setpshared \
		      pthread_condattr_getclock pthread_condattr_setclock \
		      pthread_spin_init pthread_spin_destroy \
		      pthread_spin_lock pthread_spin_trylock \
		      pthread_spin_unlock \
		      pthread_barrier_init pthread_barrier_destroy \
		      pthread_barrier_wait \
		      pthread_barrierattr_init pthread_barrierattr_destroy \
		      pthread_barrierattr_getpshared \
		      pthread_barrierattr_setpshared \
		      pthread_key_create pthread_key_delete \
		      pthread_getspecific pthread_setspecific \
		      pthread_sigmask pthread_kill \
		      pthread_cancel pthread_testcancel \
		      pthread_setcancelstate pthread_setcanceltype \
		      pthread_once \
		      old_pthread_atfork pthread_atfork \
		      pthread_getcpuclockid \
		      pthread_clock_gettime pthread_clock_settime \
		      shm-directory \
		      sem_init sem_destroy \
		      sem_open sem_close sem_unlink \
		      sem_getvalue \
		      sem_wait sem_trywait sem_timedwait sem_post \
		      cleanup cleanup_defer cleanup_compat \
		      cleanup_defer_compat unwind \
		      pt-longjmp pt-cleanup\
		      cancellation \
		      lowlevellock \
		      pt-vfork \
		      ptw-write ptw-read ptw-close ptw-fcntl ptw-accept \
		      ptw-connect ptw-recv ptw-recvfrom ptw-recvmsg ptw-send \
		      ptw-sendmsg ptw-sendto ptw-fsync ptw-lseek ptw-llseek \
		      ptw-msync ptw-nanosleep ptw-open ptw-open64 ptw-pause \
		      ptw-pread ptw-pread64 ptw-pwrite ptw-pwrite64 \
		      ptw-tcdrain ptw-wait ptw-waitpid ptw-msgrcv ptw-msgsnd \
		      ptw-sigwait ptw-sigsuspend \
		      pt-raise pt-system \
		      flockfile ftrylockfile funlockfile \
		      sigaction \
		      herrno res pt-allocrtsig \
		      pthread_kill_other_threads \
		      pthread_getaffinity pthread_setaffinity \
		      pthread_attr_getaffinity pthread_attr_setaffinity \
		      cleanup_routine unwind-forcedunwind \
		      pthread_setname pthread_getname \
		      pthread_setattr_default_np pthread_getattr_default_np

#		lowlevelrobustlock
#		pthread_sigqueue

# post linuxthreads interfaces

#		      pthread_mutexattr_getrobust pthread_mutexattr_setrobust \
#		      pthread_mutex_consistent \
#		      pthread_mutexattr_getprotocol \
#		      pthread_mutexattr_setprotocol \
#		      pthread_mutexattr_getprioceiling \
#		      pthread_mutexattr_setprioceiling tpp \
#		      pthread_mutex_getprioceiling \
#		      pthread_mutex_setprioceiling \

# commented out also in nptl

#		      pthread_setuid pthread_seteuid pthread_setreuid \
#		      pthread_setresuid \
#		      pthread_setgid pthread_setegid pthread_setregid \
#		      pthread_setresgid

libpthread-shared-only-routines = version pt-allocrtsig unwind-forcedunwind
libpthread-static-only-routines = pthread_atfork

# Since cancellation handling is in large parts handled using exceptions
# we have to compile some files with exception handling enabled, some
# even with asynchronous unwind tables.

# nptl-init.c contains sigcancel_handler().
CFLAGS-nptl-init.c = -fexceptions -fasynchronous-unwind-tables
# The unwind code itself,
CFLAGS-unwind.c = -fexceptions
CFLAGS-unwind-forcedunwind.c = -fexceptions -fasynchronous-unwind-tables

# The following three functions must be async-cancel safe.
CFLAGS-pthread_cancel.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pthread_setcancelstate.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pthread_setcanceltype.c = -fexceptions -fasynchronous-unwind-tables

# These are internal functions which similar functionality as setcancelstate
# and setcanceltype.
CFLAGS-cancellation.c = -fasynchronous-unwind-tables
CFLAGS-libc-cancellation.c = -fasynchronous-unwind-tables

# Calling pthread_exit() must cause the registered cancel handlers to
# be executed.  Therefore exceptions have to be thrown through this
# function.
CFLAGS-pthread_exit.c = -fexceptions

# Among others, __pthread_unwind is forwarded.  This function must handle
# exceptions.
CFLAGS-forward.c = -fexceptions

# The following are cancellation points.  Some of the functions can
# block and therefore temporarily enable asynchronous cancellation.
# Those must be compiled asynchronous unwind tables.
CFLAGS-pthread_testcancel.c = -fexceptions
CFLAGS-pthread_join.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pthread_timedjoin.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pthread_once.c = $(uses-callbacks) -fexceptions \
			-fasynchronous-unwind-tables
CFLAGS-pthread_cond_wait.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pthread_cond_timedwait.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-sem_wait.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-sem_timedwait.c = -fexceptions -fasynchronous-unwind-tables

# These are the function wrappers we have to duplicate here.
CFLAGS-fcntl.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-lockf.c = -fexceptions
CFLAGS-pread.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pread64.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwrite.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwrite64.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-wait.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-waitpid.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-sigwait.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-msgrcv.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-msgsnd.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-tcdrain.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-open.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-open64.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-pause.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-recv.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-send.c = -fexceptions -fasynchronous-unwind-tables

CFLAGS-pt-system.c = -fexceptions


tests = tst-typesizes \
	tst-attr1 tst-attr2 tst-attr3 tst-default-attr \
	tst-mutex1 tst-mutex2 tst-mutex3 tst-mutex4 tst-mutex5 tst-mutex6 \
	tst-mutex7 tst-mutex8 tst-mutex9 tst-mutex5a tst-mutex7a \
	tst-spin1 tst-spin2 tst-spin3 \
	tst-cond1 tst-cond2 tst-cond3 tst-cond4 tst-cond5 tst-cond6 tst-cond7 \
	tst-cond8 tst-cond9 tst-cond10 tst-cond11 tst-cond12 tst-cond13 \
	tst-cond14 tst-cond15 tst-cond16 tst-cond17 tst-cond18 tst-cond19 \
	tst-cond20 tst-cond21 tst-cond22 tst-cond23 \
	tst-rwlock1 tst-rwlock2 tst-rwlock2a tst-rwlock3 tst-rwlock4 \
	tst-rwlock5 tst-rwlock6 tst-rwlock7 tst-rwlock8 tst-rwlock9 \
	tst-rwlock10 tst-rwlock11 tst-rwlock12 tst-rwlock13 tst-rwlock14 \
	tst-once1 tst-once2 tst-once3 tst-once4 \
	tst-key1 tst-key2 tst-key3 tst-key4 \
	tst-sem1 tst-sem2 tst-sem3 tst-sem4 tst-sem5 tst-sem6 tst-sem7 \
	tst-sem8 tst-sem9 tst-sem10 tst-sem11 tst-sem12 tst-sem13 tst-sem14 \
	tst-barrier1 tst-barrier2 tst-barrier3 tst-barrier4 \
	tst-align tst-align2 tst-align3 \
	tst-basic1 tst-basic2 tst-basic3 tst-basic4 tst-basic5 tst-basic6 \
	tst-basic7 \
	tst-kill1 tst-kill2 tst-kill3 tst-kill4 tst-kill5 tst-kill6 \
	tst-raise1 \
	tst-join1 tst-join2 tst-join3 tst-join4 tst-join5 tst-join6 \
	tst-detach1 \
	tst-eintr1 tst-eintr2 tst-eintr3 tst-eintr4 tst-eintr5 \
	tst-tsd1 tst-tsd2 tst-tsd3 tst-tsd4 tst-tsd5 tst-tsd6 \
	tst-tls1 tst-tls2 \
	tst-fork1 tst-fork2 tst-fork3 tst-fork4 \
	tst-atfork1 \
	tst-cancel1 tst-cancel2 tst-cancel3 tst-cancel4 tst-cancel5 \
	tst-cancel6 tst-cancel7 tst-cancel8 tst-cancel9 tst-cancel10 \
	tst-cancel11 tst-cancel12 tst-cancel13 tst-cancel14 tst-cancel15 \
	tst-cancel16 tst-cancel17 tst-cancel18 tst-cancel19 tst-cancel20 \
	tst-cancel21 tst-cancel22 tst-cancel23 tst-cancel24 tst-cancel25 \
	tst-cancel-self tst-cancel-self-cancelstate \
	tst-cancel-self-canceltype tst-cancel-self-testcancel \
	tst-cleanup0 tst-cleanup1 tst-cleanup2 tst-cleanup3 tst-cleanup4 \
	tst-flock1 tst-flock2 \
	tst-signal1 tst-signal2 tst-signal3 tst-signal4 tst-signal5 \
	tst-signal6 tst-signal7 \
	tst-exec1 tst-exec2 tst-exec3 tst-exec4 \
	tst-exit1 tst-exit2 tst-exit3 \
	tst-stdio1 tst-stdio2 \
	tst-stack1 tst-stack2 tst-stack3 tst-pthread-getattr \
	tst-pthread-attr-affinity \
	tst-unload \
	tst-dlsym1 \
	tst-sysconf \
	tst-locale1 tst-locale2 \
	tst-umask1 \
	tst-popen1 \
	tst-clock1 \
	tst-context1 \
	tst-sched1 \
	tst-backtrace1 \
	tst-abstime \
	tst-vfork1 tst-vfork2 tst-vfork1x tst-vfork2x \
	tst-getpid1 tst-getpid2 tst-getpid3 \
	tst-initializers1 $(patsubst %,tst-initializers1-%,c89 gnu89 c99 gnu99)

# These tests do not even compile due to missing pthread_* functions
#	tst-mutexpi1 tst-mutexpi2 tst-mutexpi3 tst-mutexpi4 tst-mutexpi5 \
#	tst-mutexpi5a tst-mutexpi6 tst-mutexpi7 tst-mutexpi7a tst-mutexpi8 \

=== fbtl_db/Makefile ===
# Copyright (C) 2002-2013 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <http://www.gnu.org/licenses/>.

# Makefile for NPTL debug library subdirectory of GNU C Library.

subdir          := fbtl_db

fbtl_db-version = 1.0

extra-libs = libthread_db
extra-libs-others := $(extra-libs)

headers         = thread_db.h

libthread_db-routines = td_init td_log td_ta_new td_ta_delete \
			td_ta_get_nthreads td_ta_get_ph \
			td_ta_map_id2thr td_ta_map_lwp2thr \
			td_ta_thr_iter td_ta_tsd_iter \
			td_thr_get_info td_thr_getfpregs td_thr_getgregs \
			td_thr_getxregs td_thr_getxregsize td_thr_setfpregs \
			td_thr_setgregs td_thr_setprio td_thr_setsigpending \
			td_thr_setxregs td_thr_sigsetmask td_thr_tsd \
			td_thr_validate td_thr_dbsuspend td_thr_dbresume \
			td_ta_setconcurrency td_ta_enable_stats \
			td_ta_reset_stats td_ta_get_stats td_ta_event_addr \
			td_thr_event_enable td_thr_set_event \
			td_thr_clear_event td_thr_event_getmsg \
			td_ta_set_event td_ta_event_getmsg \
			td_ta_clear_event td_symbol_list \
			td_thr_tlsbase td_thr_tls_get_addr \
			fetch-value

libthread_db-inhibit-o = $(filter-out .os,$(object-suffixes))

# The ps_* callback functions are not defined.
libthread_db.so-no-z-defs = yes

include ../Rules

tests: $(objpfx)db-symbols.out
$(objpfx)db-symbols.out: $(objpfx)db-symbols.v.i \
			 $(common-objpfx)fbtl/libpthread.so
	LC_ALL=C $(READELF) -W -s $(filter %.so,$^) | $(AWK) -f $< > $@

$(objpfx)db-symbols.v.i: db-symbols.awk

=== nss/Makefile ===
# Copyright (C) 1996-2022 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Makefile for name service switch.
#
subdir	:= nss

include ../Makeconfig

headers			:= nss.h

# This is the trivial part which goes into libc itself.
routines		= nsswitch getnssent getnssent_r digits_dots \
			  valid_field valid_list_field rewrite_field \
			  $(addsuffix -lookup,$(databases)) \
			  compat-lookup nss_hash nss_files_fopen \
			  nss_readline nss_parse_line_result \
			  nss_fgetent_r nss_module nss_action \
			  nss_action_parse nss_database nss_files_data \
			  nss_files_functions

# These are the databases that go through nss dispatch.
# Caution: if you add a database here, you must add its real name
# in databases.def, too.
databases		= proto service hosts network grp pwd ethers \
			  spwd netgrp alias sgrp

ifneq (,$(filter sunrpc,$(subdirs)))
databases		+= key rpc
have-sunrpc		:= 1
else
have-sunrpc		:= 0
endif
CPPFLAGS-getent.c	= -DHAVE_SUNRPC=$(have-sunrpc)

others                  := getent makedb
install-bin             := getent makedb
makedb-modules = xmalloc hash-string
others-extras		= $(makedb-modules)
extra-objs		+= $(makedb-modules:=.o)

tests-static            = tst-field
tests-internal		= tst-field

tests := \
  bug17079 \
  test-digits-dots \
  test-netdb \
  tst-nss-getpwent \
  tst-nss-test1 \
  tst-nss-test2 \
  tst-nss-test4 \
  tst-nss-test5 \
# tests

xtests = bug-erange

tests-container := \
  tst-nss-compat1 \
  tst-nss-db-endgrent \
  tst-nss-db-endpwent \
  tst-nss-files-hosts-long \
  tst-nss-gai-actions \
  tst-nss-test3 \
  tst-reload1 \
  tst-reload2 \
  tst-nss-gai-hv2-canonname \
# tests-container

# Tests which need libdl
ifeq (yes,$(build-shared))
tests += tst-nss-files-hosts-erange
tests += tst-nss-files-hosts-multi
tests += tst-nss-files-hosts-getent
tests += tst-nss-files-alias-leak
tests += tst-nss-files-alias-truncated
endif

# If we have a thread library then we can test cancellation against
# some routines like getpwuid_r.
ifeq (yes,$(have-thread-library))
tests += tst-cancel-getpwuid_r
endif

# Specify rules for the nss_* modules.  We have some services.
services		:= files compat

extra-libs		= $(services:%=libnss_%)
# These libraries will be built in the `others' pass rather than
# the `lib' pass, because they depend on libc.so being built already.
extra-libs-others	= $(extra-libs)

# The sources are found in the appropriate subdir.
subdir-dirs = $(services:%=nss_%)
vpath %.c $(subdir-dirs) ../locale/programs ../intl


routines += \
  $(addprefix files-, $(filter-out key, $(databases))) \
  files-init \
  files-initgroups \
  # routines

# Build only an empty shared libnss_files.
libnss_files-inhibit-o = $(filter-out .os,$(object-suffixes))

# Pretend that libnss_files.so is a linker script, so that the symbolic link
# is not installed.
install-lib-ldscripts = libnss_files.so
$(inst_libdir)/libnss_files.so:

libnss_db-dbs		:= $(addprefix db-,\
				       $(filter-out hosts network key alias,\
						    $(databases))) \
			   db-initgroups
libnss_db-routines	:= $(libnss_db-dbs) db-open db-init hash-string
generated		+= $(filter-out db-alias.c db-netgrp.c, \
					$(addsuffix .c,$(libnss_db-dbs)))

libnss_compat-routines	:= $(addprefix compat-,grp pwd spwd initgroups) \
			   nisdomain

install-others		+= $(inst_vardbdir)/Makefile

# Build static module into libc if requested
libnss_db-inhibit-o	= $(filter-out .os,$(object-suffixes))
libnss_compat-inhibit-o	= $(filter-out .os,$(object-suffixes))
ifeq ($(build-static-nss),yes)
tests-static		+= tst-nss-static
endif
extra-test-objs		+= nss_test1.os nss_test2.os nss_test_gai_hv2_canonname.os

ifeq ($(run-built-tests),yes)
ifneq (no,$(PERL))
tests-special += $(objpfx)mtrace-tst-nss-gai-hv2-canonname.out
endif
endif

generated += mtrace-tst-nss-gai-hv2-canonname.out \
		tst-nss-gai-hv2-canonname.mtrace

include ../Rules

ifeq (yes,$(have-selinux))
LDLIBS-makedb		:= -lselinux
endif

libnss-libc = $(common-objpfx)linkobj/libc.so
# Target-specific variable setting to link objects using deprecated
# RPC interfaces with the version of libc.so that makes them available
# for new links:
$(services:%=$(objpfx)libnss_%.so): libc-for-link = $(libnss-libc)

$(libnss_db-dbs:%=$(objpfx)%.c): $(objpfx)db-%.c: nss_files/files-%.c
	@rm -f $@.new
	(echo '#define EXTERN_PARSER';\
	 echo '#define GENERIC "../nss_db/db-XXX.c"';\
	 echo '#include "$<"') > $@.new
	mv -f $@.new $@


$(objpfx)makedb: $(makedb-modules:%=$(objpfx)%.o)

$(inst_vardbdir)/Makefile: db-Makefile $(+force)
	$(do-install)

libnss_test1.so-no-z-defs = 1
libnss_test2.so-no-z-defs = 1

rtld-tests-LDFLAGS += -Wl,--dynamic-list=nss_test.ver

libof-nss_test1 = extramodules
libof-nss_test2 = extramodules
libof-nss_test_gai_hv2_canonname = extramodules
$(objpfx)/libnss_test1.so: $(objpfx)nss_test1.os $(link-libc-deps)
	$(build-module)
$(objpfx)/libnss_test2.so: $(objpfx)nss_test2.os $(link-libc-deps)
	$(build-module)
$(objpfx)/libnss_test_gai_hv2_canonname.so: \
  $(objpfx)nss_test_gai_hv2_canonname.os $(link-libc-deps)
	$(build-module)
$(objpfx)nss_test2.os : nss_test1.c
ifdef libnss_test1.so-version
$(objpfx)/libnss_test1.so$(libnss_test1.so-version): $(objpfx)/libnss_test1.so
	$(make-link)
endif
ifdef libnss_test2.so-version
$(objpfx)/libnss_test2.so$(libnss_test2.so-version): $(objpfx)/libnss_test2.so
	$(make-link)
endif
$(objpfx)/libnss_test_gai_hv2_canonname.so$(libnss_files.so-version): \
  $(objpfx)/libnss_test_gai_hv2_canonname.so
	$(make-link)
$(patsubst %,$(objpfx)%.out,$(tests) $(tests-container)) : \
	$(objpfx)/libnss_test1.so$(libnss_test1.so-version) \
	$(objpfx)/libnss_test2.so$(libnss_test2.so-version) \
	$(objpfx)/libnss_test_gai_hv2_canonname.so$(libnss_files.so-version)

ifeq (yes,$(have-thread-library))
$(objpfx)tst-cancel-getpwuid_r: $(shared-thread-library)
endif

$(objpfx)tst-nss-files-alias-leak.out: $(objpfx)/libnss_files.so
$(objpfx)tst-nss-files-alias-truncated.out: $(objpfx)/libnss_files.so

tst-nss-gai-hv2-canonname-ENV = \
		MALLOC_TRACE=$(objpfx)tst-nss-gai-hv2-canonname.mtrace \
		LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
$(objpfx)mtrace-tst-nss-gai-hv2-canonname.out: \
  $(objpfx)tst-nss-gai-hv2-canonname.out
	{ test -r $(objpfx)tst-nss-gai-hv2-canonname.mtrace \
	|| ( echo "tst-nss-gai-hv2-canonname.mtrace does not exist"; exit 77; ) \
	&& $(common-objpfx)malloc/mtrace \
	$(objpfx)tst-nss-gai-hv2-canonname.mtrace; } > $@; \
	$(evaluate-test)

# Disable DT_RUNPATH on NSS tests so that the glibc internal NSS
# functions can load testing NSS modules via DT_RPATH.
LDFLAGS-tst-nss-test1 = -Wl,--disable-new-dtags
LDFLAGS-tst-nss-test2 = -Wl,--disable-new-dtags
LDFLAGS-tst-nss-test3 = -Wl,--disable-new-dtags
LDFLAGS-tst-nss-test4 = -Wl,--disable-new-dtags
LDFLAGS-tst-nss-test5 = -Wl,--disable-new-dtags
LDFLAGS-tst-nss-test_gai_hv2_canonname = -Wl,--disable-new-dtags

=== stdio-common/Makefile ===
# Copyright (C) 1991-2022 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Specific makefile for stdio-common.
#
subdir	:= stdio-common

include ../Makeconfig

headers	:= stdio_ext.h printf.h bits/printf-ldbl.h bits/stdio_lim.h

routines	:=							      \
	ctermid cuserid							      \
	_itoa _itowa itoa-digits itoa-udigits itowa-digits		      \
	vfprintf vprintf printf_fp reg-printf printf-prs printf_fphex	      \
	reg-modifier reg-type						      \
	printf_size fprintf printf snprintf sprintf asprintf dprintf	      \
	vfwprintf vfscanf vfwscanf					      \
	fscanf scanf sscanf						      \
	perror psignal							      \
	tmpfile tmpfile64 tmpnam tmpnam_r tempnam tempname		      \
	getline getw putw						      \
	remove rename renameat renameat2				      \
	flockfile ftrylockfile funlockfile				      \
	isoc99_scanf isoc99_vscanf isoc99_fscanf isoc99_vfscanf isoc99_sscanf \
	isoc99_vsscanf							      \
	psiginfo gentempfd						      \
	vfscanf-internal vfwscanf-internal iovfscanf			      \
	vfprintf-internal vfwprintf-internal

aux	:= errlist siglist printf-parsemb printf-parsewc fxprintf

tests := tstscanf test_rdwr test-popen tstgetln test-fseek \
	 temptest tst-fileno test-fwrite tst-ungetc tst-ferror \
	 xbug errnobug \
	 bug1 bug2 bug3 bug4 bug5 bug6 bug7 bug8 bug9 bug10 bug11 bug12 bug13 \
	 tfformat tiformat tllformat tstdiomisc tst-printfsz tst-wc-printf \
	 scanf1 scanf2 scanf3 scanf4 scanf5 scanf7 scanf8 scanf9 scanf10 \
	 scanf11 scanf12 tst-tmpnam tst-cookie tst-obprintf tst-sscanf \
	 tst-swprintf tst-fseek tst-fmemopen test-vfprintf tst-gets \
	 tst-perror tst-sprintf tst-rndseek tst-fdopen tst-fphex bug14 \
	 tst-popen tst-unlockedio tst-fmemopen2 tst-put-error tst-fgets \
	 tst-fwrite bug16 bug17 tst-swscanf tst-sprintf2 bug18 bug18a \
	 bug19 bug19a tst-popen2 scanf13 scanf14 scanf15 bug20 bug21 bug22 \
	 scanf16 scanf17 tst-setvbuf1 tst-grouping bug23 bug24 \
	 bug-vfprintf-nargs tst-long-dbl-fphex tst-fphex-wide tst-sprintf3 \
	 bug25 tst-printf-round bug23-2 bug23-3 bug23-4 bug26 tst-fmemopen3 \
	 tst-printf-bz18872 tst-vfprintf-width-prec tst-fmemopen4 \
	 tst-vfprintf-user-type \
	 tst-vfprintf-mbs-prec \
	 tst-scanf-round \
	 tst-renameat2 tst-bz11319 tst-bz11319-fortify2 \
	 scanf14a scanf16a \
	 tst-printf-bz25691 \
	 tst-vfprintf-width-prec-alloc \
	 tst-printf-fp-free \
	 tst-printf-fp-leak \
	 test-strerr \
	 tst-printf-binary \
	 tst-sprintf-errno \
	 # tests


test-srcs = tst-unbputc tst-printf tst-printfsz-islongdouble

ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-unbputc.out $(objpfx)tst-printf.out \
		 $(objpfx)tst-printf-bz18872-mem.out \
		 $(objpfx)tst-setvbuf1-cmp.out \
		 $(objpfx)tst-vfprintf-width-prec-mem.out \
		 $(objpfx)tst-printfsz-islongdouble.out \
		 $(objpfx)tst-printf-bz25691-mem.out \
		 $(objpfx)tst-printf-fp-free-mem.out \
		 $(objpfx)tst-printf-fp-leak-mem.out
generated += tst-printf-bz18872.c tst-printf-bz18872.mtrace \
	     tst-printf-bz18872-mem.out \
	     tst-vfprintf-width-prec.mtrace tst-vfprintf-width-prec-mem.out \
	     tst-printf-bz25691.mtrace tst-printf-bz25691-mem.out \
	     tst-printf-fp-free.mtrace tst-printf-fp-free-mem.out \
	     tst-printf-fp-leak.mtrace tst-printf-fp-leak-mem.out
endif

# tests-special += $(objpfx)tst-errno-manual.out

include ../Rules

ifeq ($(run-built-tests),yes)
LOCALES := de_DE.ISO-8859-1 de_DE.UTF-8 en_US.ISO-8859-1 ja_JP.EUC-JP
include ../gen-locales.mk

$(objpfx)bug14.out: $(gen-locales)
$(objpfx)scanf13.out: $(gen-locales)
$(objpfx)test-vfprintf.out: $(gen-locales)
$(objpfx)tst-grouping.out: $(gen-locales)
$(objpfx)tst-sprintf.out: $(gen-locales)
$(objpfx)tst-sscanf.out: $(gen-locales)
$(objpfx)tst-swprintf.out: $(gen-locales)
$(objpfx)tst-vfprintf-mbs-prec.out: $(gen-locales)
endif

tst-printf-bz18872-ENV = MALLOC_TRACE=$(objpfx)tst-printf-bz18872.mtrace \
			LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
tst-vfprintf-width-prec-ENV = \
  MALLOC_TRACE=$(objpfx)tst-vfprintf-width-prec.mtrace \
  LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
tst-printf-bz25691-ENV = \
  MALLOC_TRACE=$(objpfx)tst-printf-bz25691.mtrace \
  LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
tst-printf-fp-free-ENV = \
  MALLOC_TRACE=$(objpfx)tst-printf-fp-free.mtrace \
  LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
tst-printf-fp-leak-ENV = \
  MALLOC_TRACE=$(objpfx)tst-printf-fp-leak.mtrace \
  LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so

$(objpfx)tst-unbputc.out: tst-unbputc.sh $(objpfx)tst-unbputc
	$(SHELL) $< $(common-objpfx) '$(test-program-prefix)'; \
	$(evaluate-test)

$(objpfx)tst-printf.out: tst-printf.sh $(objpfx)tst-printf
	$(SHELL) $< $(common-objpfx) '$(test-program-prefix)'; \
	$(evaluate-test)

$(objpfx)tst-printfsz-islongdouble.out: \
  tst-printfsz-islongdouble.sh $(objpfx)tst-printfsz-islongdouble
	$(SHELL) $^ '$(test-program-prefix)' $@; \
	$(evaluate-test)

# We generate this source because it requires a printf invocation with
# 10K arguments.
$(objpfx)tst-printf-bz18872.c: tst-printf-bz18872.sh
	rm -f $@ && $(BASH) $^ > $@.new && mv $@.new $@

$(objpfx)tst-%-mem.out: $(objpfx)tst-%.out
	$(common-objpfx)malloc/mtrace $(objpfx)tst-$*.mtrace > $@; \
	$(evaluate-test)

errlist-h = $(firstword $(wildcard $(addsuffix /errlist.h,$(sysdirs) .)))

$(objpfx)tst-errno-manual.out: tst-errno-manual.py \
			       $(errlist-h) \
			       $(..)manual/errno.texi
	$(PYTHON) tst-errno-manual.py -m $(..)manual/errno.texi \
				      -e $(errlist-h) > $@; \
	$(evaluate-test)

CFLAGS-vfprintf.c += -Wno-uninitialized
CFLAGS-vfwprintf.c += -Wno-uninitialized

CFLAGS-tmpfile.c += -fexceptions
CFLAGS-tmpfile64.c += -fexceptions
CFLAGS-tempname.c += -fexceptions
CFLAGS-psignal.c += -fexceptions
CFLAGS-vprintf.c += -fexceptions
CFLAGS-cuserid.c += -fexceptions

CFLAGS-vfprintf.c += -fexceptions
CFLAGS-fprintf.c += -fexceptions
CFLAGS-printf.c += -fexceptions
CFLAGS-vfwprintf.c += -fexceptions
CFLAGS-vfscanf.c += -fexceptions
CFLAGS-vfwscanf.c += -fexceptions
CFLAGS-fscanf.c += -fexceptions
CFLAGS-scanf.c += -fexceptions
CFLAGS-isoc99_vfscanf.c += -fexceptions
CFLAGS-isoc99_vscanf.c += -fexceptions
CFLAGS-isoc99_fscanf.c += -fexceptions
CFLAGS-isoc99_scanf.c += -fexceptions
CFLAGS-errlist.c += $(fno-unit-at-a-time)
CFLAGS-siglist.c += $(fno-unit-at-a-time)

# scanf14a.c and scanf16a.c test a deprecated extension which is no
# longer visible under most conformance levels; see the source files
# for more detail.
CFLAGS-scanf14a.c += -std=gnu89
CFLAGS-scanf16a.c += -std=gnu89

CFLAGS-bug3.c += -DOBJPFX=\"$(objpfx)\"
CFLAGS-bug4.c += -DOBJPFX=\"$(objpfx)\"
CFLAGS-bug5.c += -DOBJPFX=\"$(objpfx)\"
CFLAGS-test-fseek.c += -DOBJPFX=\"$(objpfx)\"
CFLAGS-test-popen.c += -DOBJPFX=\"$(objpfx)\"
CFLAGS-test_rdwr.c += -DOBJPFX=\"$(objpfx)\"

# tst-gets.c tests a deprecated function.
CFLAGS-tst-gets.c += -Wno-deprecated-declarations

# BZ #11319 was first fixed for regular vdprintf, then reopened because
# the fortified version had the same bug.
CFLAGS-tst-bz11319-fortify2.c += -D_FORTIFY_SOURCE=2

CPPFLAGS += $(libio-mtsafe)

$(objpfx)tst-setvbuf1.out: /dev/null $(objpfx)tst-setvbuf1
	$(test-program-cmd) > $@ 2>&1; \
	$(evaluate-test)

$(objpfx)tst-setvbuf1-cmp.out: tst-setvbuf1.expect $(objpfx)tst-setvbuf1.out
	cmp $^ > $@; \
	$(evaluate-test)

$(objpfx)tst-printf-round: $(libm)
$(objpfx)tst-scanf-round: $(libm)

=== sysdeps/hppa/Makefile ===
# Copyright (C) 2000-2022 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library.  If not, see
# <https://www.gnu.org/licenses/>.

# We used to need this since the build process uses ld -r.  Now we use
# ld -r --unique=.text* which does more or less the same thing, but better.
# CFLAGS-.os += -ffunction-sections
LDFLAGS-c_pic.os += -Wl,--unique=.text*

ifeq ($(subdir),elf)
CFLAGS-rtld.c += -mdisable-fpregs
CFLAGS-dl-reloc.c += --param inline-unit-growth=100
sysdep-dl-routines += dl-symaddr dl-fptr
# dl-fptr.c needs a complete rewrite to fix ISO C aliasing violations.
CFLAGS-dl-fptr.c = -Wno-error
endif

ifeq ($(subdir),csu)
ifeq (yes,$(build-shared))
# Compatibility
ifeq (yes,$(have-protected))
CPPFLAGS-libgcc-compat.c = -DHAVE_DOT_HIDDEN
endif
sysdep_routines += libgcc-compat
shared-only-routines += libgcc-compat
endif
endif

# We implement a 64-bit `long double'. The standard says we can do this.
# This means our `long double' and `double' are identical.
long-double-fcts = no

=== .pc/any/local-test-install.diff/Makefile ===
# Copyright (C) 1991-2022 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Master Makefile for the GNU C library
#
ifneq (,)
This makefile requires GNU Make.
endif

include Makeconfig


# This is the default target; it makes everything except the tests.
.PHONY: all help minihelp
all: minihelp lib others

help:
	@sed '0,/^help-starts-here$$/d' Makefile.help

minihelp:
	@echo
	@echo type \"make help\" for help with common glibc makefile targets
	@echo


ifneq ($(AUTOCONF),no)

define autoconf-it
@-rm -f $@.new
$(AUTOCONF) $(ACFLAGS) $< > $@.new
chmod a-w$(patsubst %,$(comma)a+x,$(filter .,$(@D))) $@.new
mv -f $@.new $@
endef

configure: configure.ac aclocal.m4; $(autoconf-it)
%/configure: %/configure.ac aclocal.m4; $(autoconf-it)
%/preconfigure: %/preconfigure.ac aclocal.m4; $(autoconf-it)

endif # $(AUTOCONF) = no


# We don't want to run anything here in parallel.
.NOTPARALLEL:

# These are the targets that are made by making them in each subdirectory.
+subdir_targets	:= subdir_lib objects objs others subdir_mostlyclean	\
		   subdir_clean subdir_distclean subdir_realclean	\
		   tests xtests						\
		   subdir_update-abi subdir_check-abi			\
		   subdir_update-all-abi				\
		   subdir_echo-headers					\
		   subdir_install					\
		   subdir_objs subdir_stubs subdir_testclean		\
		   $(addprefix install-, no-libc.a bin lib data headers others)

headers := limits.h values.h features.h features-time64.h gnu-versions.h \
	   bits/xopen_lim.h gnu/libc-version.h stdc-predef.h \
	   bits/libc-header-start.h

echo-headers: subdir_echo-headers

# The headers are in the include directory.
subdir-dirs = include
vpath %.h $(subdir-dirs)

# What to install.
install-others = $(inst_includedir)/gnu/stubs.h
install-bin-script =

ifeq (yes,$(build-shared))
headers += gnu/lib-names.h
endif

include Makerules

ifeq ($(build-programs),yes)
others: $(addprefix $(objpfx),$(install-bin-script))
endif

# Install from subdirectories too.
install: subdir_install

# Explicit dependency so that `make install-headers' works
install-headers: install-headers-nosubdir

# Make sure that the dynamic linker is installed before libc.
$(inst_slibdir)/libc-$(version).so: elf/ldso_install

.PHONY: elf/ldso_install
elf/ldso_install:
	$(MAKE) -C $(@D) $(@F)

# Create links for shared libraries using the `ldconfig' program if possible.
# Ignore the error if we cannot update /etc/ld.so.cache.
ifeq (no,$(cross-compiling))
ifeq (yes,$(build-shared))
install:
	-test ! -x $(elf-objpfx)ldconfig || LC_ALL=C \
	  $(elf-objpfx)ldconfig $(addprefix -r ,$(install_root)) \
				$(slibdir) $(libdir)
ifneq (no,$(PERL))
ifeq (/usr,$(prefix))
ifeq (,$(install_root))
	LD_SO=$(ld.so-version) CC="$(CC)" $(PERL) scripts/test-installation.pl $(common-objpfx)
endif
endif
endif
endif
endif

# Build subdirectory lib objects.
lib-noranlib: subdir_lib

ifeq (yes,$(build-shared))
# Build the shared object from the PIC object library.
lib: $(common-objpfx)libc.so $(common-objpfx)linkobj/libc.so
endif # $(build-shared)

# Used to build testrun.sh.
define testrun-script
#!/bin/bash
builddir=`dirname "$$0"`
GCONV_PATH="$${builddir}/iconvdata"

usage () {
cat << EOF
Usage: $$0 [OPTIONS] <program> [ARGUMENTS...]

  --tool=TOOL  Run with the specified TOOL. It can be strace, rpctrace,
               valgrind or container. The container will run within
               support/test-container.
EOF

  exit 1
}

toolname=default
while test $$# -gt 0 ; do
  case "$$1" in
    --tool=*)
      toolname="$${1:7}"
      shift
      ;;
    --*)
      usage
      ;;
    *)
      break
      ;;
  esac
done

if test $$# -eq 0 ; then
  usage
fi

case "$$toolname" in
  default)
    exec $(subst $(common-objdir),"$${builddir}", $(test-program-prefix)) \
      $${1+"$$@"}
    ;;
  strace)
    exec strace $(patsubst %, -E%, $(run-program-env)) \
      $(test-via-rtld-prefix) $${1+"$$@"}
    ;;
  rpctrace)
    exec rpctrace $(patsubst %, -E%, $(run-program-env)) \
      $(test-via-rtld-prefix) $${1+"$$@"}
    ;;
  valgrind)
    exec env $(run-program-env) valgrind $(test-via-rtld-prefix) $${1+"$$@"}
    ;;
  container)
    exec env $(run-program-env) $(test-via-rtld-prefix) \
      $(common-objdir)/support/test-container \
      env $(run-program-env) $(test-via-rtld-prefix) $${1+"$$@"}
    ;;
  *)
    usage
    ;;
esac
endef

# This is a handy script for running any dynamically linked program against
# the current libc build for testing.
$(common-objpfx)testrun.sh: $(common-objpfx)config.make \
			    $(..)Makeconfig $(..)Makefile
	$(file >$@T,$(testrun-script))
	chmod a+x $@T
	mv -f $@T $@
postclean-generated += testrun.sh

define debugglibc
#!/bin/bash

SOURCE_DIR="$(CURDIR)"
BUILD_DIR="$(common-objpfx)"
CMD_FILE="$(common-objpfx)debugglibc.gdb"
CONTAINER=false
DIRECT=true
STATIC=false
SYMBOLSFILE=true
unset TESTCASE
unset BREAKPOINTS
unset ENVVARS

usage()
{
cat << EOF
Usage: $$0 [OPTIONS] <program>

   Or: $$0 [OPTIONS] -- <program> [<args>]...

  where <program> is the path to the program being tested,
  and <args> are the arguments to be passed to it.

Options:

  -h, --help
	Prints this message and leaves.

  The following options require one argument:

  -b, --breakpoint
	Breakpoints to set at the beginning of the execution
	(each breakpoint demands its own -b option, e.g. -b foo -b bar)
  -e, --environment-variable
	Environment variables to be set with 'exec-wrapper env' in GDB
	(each environment variable demands its own -e option, e.g.
	-e FOO=foo -e BAR=bar)

  The following options do not take arguments:

  -c, --in-container
	Run the test case inside a container and automatically attach
	GDB to it.
  -i, --no-direct
	Selects whether to pass the --direct flag to the program.
	--direct is useful when debugging glibc test cases. It inhibits the
	tests from forking and executing in a subprocess.
	Default behaviour is to pass the --direct flag, except when the
	program is run with user specified arguments using the "--" separator.
  -s, --no-symbols-file
	Do not tell GDB to load debug symbols from the program.
EOF
}

# Parse input options
while [[ $$# > 0 ]]
do
  key="$$1"
  case $$key in
    -h|--help)
      usage
      exit 0
      ;;
    -b|--breakpoint)
      BREAKPOINTS="break $$2\n$$BREAKPOINTS"
      shift
      ;;
    -e|--environment-variable)
      ENVVARS="$$2 $$ENVVARS"
      shift
      ;;
    -c|--in-container)
      CONTAINER=true
      ;;
    -i|--no-direct)
      DIRECT=false
      ;;
    -s|--no-symbols-file)
      SYMBOLSFILE=false
      ;;
    --)
      shift
      TESTCASE=$$1
      COMMANDLINE="$$@"
      # Don't add --direct when user specifies program arguments
      DIRECT=false
      break
      ;;
    *)
      TESTCASE=$$1
      COMMANDLINE=$$TESTCASE
      ;;
  esac
  shift
done

# Check for required argument and if the testcase exists
if [ ! -v TESTCASE ] || [ ! -f $${TESTCASE} ]
then
  usage
  exit 1
fi

# Container tests needing locale data should install them in-container.
# Other tests/binaries need to use locale data from the build tree.
if [ "$$CONTAINER" = false ]
then
  ENVVARS="GCONV_PATH=$${BUILD_DIR}/iconvdata $$ENVVARS"
  ENVVARS="LOCPATH=$${BUILD_DIR}/localedata $$ENVVARS"
  ENVVARS="LC_ALL=C $$ENVVARS"
fi

# Expand environment setup command
if [ -v ENVVARS ]
then
  ENVVARSCMD="set exec-wrapper env $$ENVVARS"
fi

# Expand direct argument
if [ "$$DIRECT" == true ]
then
  DIRECT="--direct"
else
  DIRECT=""
fi

# Check if the test case is static
if file $${TESTCASE} | grep "statically linked" >/dev/null
then
  STATIC=true
else
  STATIC=false
fi

# Expand symbols loading command
if [ "$$SYMBOLSFILE" == true ]
then
  SYMBOLSFILE="add-symbol-file $${TESTCASE}"
else
  SYMBOLSFILE=""
fi

# GDB commands template
template ()
{
cat <<EOF
set environment C -E -x c-header
set auto-load safe-path $${BUILD_DIR}/nptl_db:\$$debugdir:\$$datadir/auto-load
set libthread-db-search-path $${BUILD_DIR}/nptl_db
__ENVVARS__
__SYMBOLSFILE__
break _dl_start_user
run --library-path $(rpath-link):$${BUILD_DIR}/nptl_db \
__COMMANDLINE__ __DIRECT__
__BREAKPOINTS__
EOF
}

# Generate the commands file for gdb initialization
template | sed \
  -e "s|__ENVVARS__|$$ENVVARSCMD|" \
  -e "s|__SYMBOLSFILE__|$$SYMBOLSFILE|" \
  -e "s|__COMMANDLINE__|$$COMMANDLINE|" \
  -e "s|__DIRECT__|$$DIRECT|" \
  -e "s|__BREAKPOINTS__|$$BREAKPOINTS|" \
  > $$CMD_FILE

echo
echo "Debugging glibc..."
echo "Build directory  : $$BUILD_DIR"
echo "Source directory : $$SOURCE_DIR"
echo "GLIBC Testcase   : $$TESTCASE"
echo "GDB Commands     : $$CMD_FILE"
echo "Env vars         : $$ENVVARS"
echo

if [ "$$CONTAINER" == true ]
then
# Use testrun.sh to start the test case with WAIT_FOR_DEBUGGER=1, then
# automatically attach GDB to it.
WAIT_FOR_DEBUGGER=1 $(common-objpfx)testrun.sh --tool=container $${TESTCASE} &
gdb -x $${TESTCASE}.gdb
elif [ "$$STATIC" == true ]
then
gdb $${TESTCASE}
else
# Start the test case debugging in two steps:
#   1. the following command invokes gdb to run the loader;
#   2. the commands file tells the loader to run the test case.
gdb -q \
  -x $${CMD_FILE} \
  -d $${SOURCE_DIR} \
  $${BUILD_DIR}/elf/ld.so
fi
endef

# This is another handy script for debugging dynamically linked program
# against the current libc build for testing.
$(common-objpfx)debugglibc.sh: $(common-objpfx)config.make \
			    $(..)Makeconfig $(..)Makefile
	$(file >$@T,$(debugglibc))
	chmod a+x $@T
	mv -f $@T $@
postclean-generated += debugglibc.sh debugglibc.gdb

others: $(common-objpfx)testrun.sh $(common-objpfx)debugglibc.sh

# Makerules creates a file `stubs' in each subdirectory, which
# contains `#define __stub_FUNCTION' for each function defined in that
# directory which is a stub.
# Here we paste all of these together into <gnu/stubs.h>.

subdir-stubs := $(foreach dir,$(subdirs),$(common-objpfx)$(dir)/stubs)

ifndef abi-variants
installed-stubs = $(inst_includedir)/gnu/stubs.h
else
installed-stubs = $(inst_includedir)/gnu/stubs-$(default-abi).h

$(inst_includedir)/gnu/stubs.h: $(+force)
	$(make-target-directory)
	{ \
	 echo '/* This file is automatically generated.';\
	 echo "   This file selects the right generated file of \`__stub_FUNCTION' macros";\
	 echo '   based on the architecture being compiled for.  */'; \
	 echo ''; \
	 $(foreach h,$(abi-includes), echo '#include <$(h)>';) \
	 echo ''; \
	 $(foreach v,$(abi-variants),\
	 $(if $(abi-$(v)-condition),\
	 echo '#if $(abi-$(v)-condition)'; \
	 echo '# include <gnu/stubs-$(v).h>'); \
	 $(if $(abi-$(v)-condition),echo '#endif';) \
	 rm -f $(@:.d=.h).new$(v); \
	 ) \
	} > $(@:.d=.h).new
	mv -f $(@:.d=.h).new $(@:.d=.h)

install-others-nosubdir: $(installed-stubs)
endif

# If we're bootstrapping, install a dummy gnu/stubs.h along with the
# other headers, so 'make install-headers' produces a useable include
# tree.  Otherwise, install gnu/stubs.h later, after the rest of the
# build is done.
ifeq ($(install-bootstrap-headers),yes)
install-headers: $(inst_includedir)/gnu/stubs.h $(installed-stubs) \
		 $(inst_includedir)/$(lib-names-h-abi)
endif

# Since stubs.h is never needed when building the library, we simplify the
# hairy installation process by producing it in place only as the last part
# of the top-level `make install'.  It depends on subdir_install, which

=== .pc/git-updates.diff/elf/Makefile ===
# Copyright (C) 1995-2022 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

# Makefile for elf subdirectory of GNU C Library.

subdir		:= elf

include ../Makeconfig

headers = \
  bits/elfclass.h \
  bits/link.h \
  bits/link_lavcurrent.h \
  elf.h \
  link.h \
  # headers

routines = \
  $(all-dl-routines) \
  dl-addr \
  dl-addr-obj \
  dl-error \
  dl-iteratephdr \
  dl-libc \
  dl-origin \
  dl-profstub \
  dl-reloc-static-pie \
  dl-support \
  dl-sym \
  dl-sysdep \
  enbl-secure \
  libc-dl_find_object \
  libc_early_init \
  rtld_static_init \
  # routines

# The core dynamic linking functions are in libc for the static and
# profiled libraries.
dl-routines = \
  dl-call-libc-early-init \
  dl-close \
  dl-debug \
  dl-debug-symbols \
  dl-deps \
  dl-exception \
  dl-execstack \
  dl-find_object \
  dl-fini \
  dl-init \
  dl-load \
  dl-lookup \
  dl-lookup-direct \
  dl-minimal-malloc \
  dl-misc \
  dl-object \
  dl-open \
  dl-origin \
  dl-printf \
  dl-profile \
  dl-reloc \
  dl-runtime \
  dl-scope \
  dl-setup_hash \
  dl-sort-maps \
  dl-thread_gscope_wait \
  dl-tls \
  dl-tls_init_tp \
  dl-trampoline \
  dl-version \
  dl-write \
  # dl-routines

ifeq (yes,$(use-ldconfig))
dl-routines += dl-cache
endif

ifneq (no,$(have-tunables))
dl-routines += dl-tunables
tunables-type = $(addprefix TUNABLES_FRONTEND_,$(have-tunables))
CPPFLAGS-dl-tunables.c += -DTUNABLES_FRONTEND=$(tunables-type)

ifeq (yesyes,$(build-shared)$(run-built-tests))
tests-special += $(objpfx)list-tunables.out
endif

# Make sure that the compiler does not insert any library calls in tunables
# code paths.
ifeq (yes,$(have-loop-to-function))
CFLAGS-dl-tunables.c += -fno-tree-loop-distribute-patterns
endif
endif

all-dl-routines = $(dl-routines) $(sysdep-dl-routines)
# But they are absent from the shared libc, because that code is in ld.so.
elide-routines.os = \
  $(all-dl-routines) \
  dl-exception \
  dl-origin \
  dl-reloc-static-pie \
  dl-support \
  dl-sysdep \
  enbl-secure \
  rtld_static_init \
  thread_gscope_wait \
  # elide-routines.os

# These object files are only included in the dynamically-linked libc.
shared-only-routines = libc-dl_find_object

# ld.so uses those routines, plus some special stuff for being the program
# interpreter and operating independent of libc.
rtld-routines = \
  $(all-dl-routines) \
  dl-audit \
  dl-compat \
  dl-conflict \
  dl-diagnostics \
  dl-diagnostics-cpu \
  dl-diagnostics-kernel \
  dl-environ \
  dl-error-minimal \
  dl-hwcaps \
  dl-hwcaps-subdirs \
  dl-hwcaps_split \
  dl-libc_freeres \
  dl-minimal \
  dl-mutex \
  dl-sysdep \
  dl-usage \
  rtld \
  # rtld-routines

all-rtld-routines = $(rtld-routines) $(sysdep-rtld-routines)

CFLAGS-dl-runtime.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-dl-lookup.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-dl-iteratephdr.c += $(uses-callbacks)

# Called during static library initialization, so turn stack-protection
# off for non-shared builds.
CFLAGS-dl-minimal-malloc.o = $(no-stack-protector)
CFLAGS-dl-minimal-malloc.op = $(no-stack-protector)

# On targets without __builtin_memset, rtld.c uses a hand-coded loop
# in _dl_start.  Make sure this isn't turned into a call to regular memset.
ifeq (yes,$(have-loop-to-function))
CFLAGS-rtld.c += -fno-tree-loop-distribute-patterns
endif

# Compile rtld itself without stack protection.
# Also compile all routines in the static library that are elided from
# the shared libc because they are in libc.a in the same way.

CFLAGS-.o += $(call elide-stack-protector,.o,$(elide-routines.os))
CFLAGS-.op += $(call elide-stack-protector,.op,$(elide-routines.os))
CFLAGS-.os += $(call elide-stack-protector,.os,$(all-rtld-routines))

# Add the requested compiler flags to the early startup code.
CFLAGS-dl-printf.os += $(rtld-early-cflags)
CFLAGS-dl-setup_hash.os += $(rtld-early-cflags)
CFLAGS-dl-sysdep.os += $(rtld-early-cflags)
CFLAGS-dl-tunables.os += $(rtld-early-cflags)
CFLAGS-dl-write.os += $(rtld-early-cflags)
CFLAGS-dl-writev.os += $(rtld-early-cflags)
CFLAGS-rtld.os += $(rtld-early-cflags)

ifeq ($(unwind-find-fde),yes)
routines += unwind-dw2-fde-glibc
shared-only-routines += unwind-dw2-fde-glibc
endif

before-compile  += $(objpfx)trusted-dirs.h
generated	+= trusted-dirs.h trusted-dirs.st for-renamed/renamed.so
generated-dirs	+= for-renamed

ifeq ($(build-shared),yes)
ld-map		= $(common-objpfx)ld.map
endif

ifeq (yes,$(build-shared))
extra-objs = \
  $(all-rtld-routines:%=%.os) \
  sofini.os \
  interp.os \
  # extra-objs
generated += \
  dl-allobjs.os \
  ld.so ldd \
  librtld.os \
  # generated
install-others	= $(inst_rtlddir)/$(rtld-installed-name) $(inst_bindir)/ld.so
install-bin-script = ldd
endif

others		= sprof sln
install-bin	= sprof
others-static   = sln
install-rootsbin = sln
sln-modules	:= static-stubs
extra-objs	+= $(sln-modules:=.o)

ifeq (yes,$(use-ldconfig))
ifeq (yes,$(build-shared))
others-static	+= ldconfig
others		+= ldconfig
install-rootsbin += ldconfig

ldconfig-modules := \
  cache \
  chroot_canon \
  readlib \
  static-stubs \
  stringtable \
  xmalloc \
  xstrdup \
  # ldconfig-modules
extra-objs	+= $(ldconfig-modules:=.o)
others-extras   = $(ldconfig-modules)
endif
endif

# To find xmalloc.c and xstrdup.c
vpath %.c ../locale/programs

ifeq ($(build-shared),yes)
extra-objs += sotruss-lib.os sotruss-lib.so
install-others += $(inst_auditdir)/sotruss-lib.so
install-bin-script += sotruss
generated += sotruss
libof-sotruss-lib = extramodules
LDFLAGS-sotruss-lib.so += $(z-now-$(bind-now))
$(objpfx)sotruss-lib.so: $(objpfx)sotruss-lib.os
	$(build-module-asneeded)
$(objpfx)sotruss-lib.so: $(common-objpfx)libc.so $(objpfx)ld.so \
	$(common-objpfx)libc_nonshared.a

$(objpfx)sotruss: sotruss.sh $(common-objpfx)config.make
	sed -e 's%@VERSION@%$(version)%g' \
	    -e 's%@TEXTDOMAINDIR@%$(localedir)%g' \
	    -e 's%@PREFIX@%$(prefix)%g' \
	    -e 's|@PKGVERSION@|$(PKGVERSION)|g' \
	    -e 's|@REPORT_BUGS_TO@|$(REPORT_BUGS_TO)|g' \
	    < $< > $@.new
	chmod 555 $@.new
	mv -f $@.new $@
$(inst_auditdir)/sotruss-lib.so: $(objpfx)sotruss-lib.so $(+force)
	$(do-install-program)
endif

tests-static-normal := \
  tst-array1-static \
  tst-array5-static \
  tst-dl-iter-static \
  tst-dst-static \
  tst-env-setuid \
  tst-env-setuid-tunables \
  tst-getauxval-static \
  tst-linkall-static \
  tst-single_threaded-pthread-static \
  tst-single_threaded-static \
  tst-tlsalign-extern-static \
  tst-tlsalign-static \
  # tests-static-normal

tests-static-internal := \
  tst-dl_find_object-static \
  tst-ptrguard1-static \
  tst-stackguard1-static \
  tst-tls1-static \
  tst-tls1-static-non-pie \
  # tests-static-internal

CRT-tst-tls1-static-non-pie := $(csu-objpfx)crt1.o
tst-tls1-static-non-pie-no-pie = yes

tests-container := \
  tst-ldconfig-bad-aux-cache \
  tst-ldconfig-ld_so_conf-update \
  # tests-container

ifeq (no,$(build-hardcoded-path-in-tests))
# This is an ld.so.cache test, and RPATH/RUNPATH in the executable
# interferes with its test objectives.
tests-container += tst-glibc-hwcaps-prepend-cache
endif

tests := \
  tst-array1 \
  tst-array2 \
  tst-array3 \
  tst-array4 \
  tst-array5 \
  tst-auxv \
  tst-leaks1 \
  tst-stringtable \
  tst-tls9 \
  # tests

tests-internal := \
  $(tests-static-internal) \
  tst-tls1 \
  # tests-internal

tests-static := $(tests-static-normal) $(tests-static-internal)

ifeq (yes,$(build-shared))
tests-static += \
  tst-single_threaded-static-dlopen \
  tst-tls9-static \
  # tests-static

static-dlopen-environment = \
  LD_LIBRARY_PATH=$(ld-library-path):$(common-objpfx)dlfcn
tst-tls9-static-ENV = $(static-dlopen-environment)
tst-single_threaded-static-dlopen-ENV = $(static-dlopen-environment)

tests += \
  argv0test \
  constload1 \
  dblload \
  dblunload \
  filter \
  global \
  initfirst \
  lateglobal \
  loadfail \
  multiload \
  next \
  nodelete \
  nodelete2 \
  nodlopen \
  nodlopen2 \
  noload \
  order \
  order2 \
  origtest \
  preloadtest \
  reldep \
  reldep2 \
  reldep3 \
  reldep4 \
  reldep5 \
  reldep6 \
  reldep7 \
  reldep8 \
  resolvfail \
  restest1 \
  restest2 \
  tst-absolute-sym \
  tst-absolute-zero \
  tst-addr1 \
  tst-align \
  tst-align2 \
  tst-align3 \
  tst-audit1 \
  tst-audit2 \
  tst-audit8 \
  tst-audit9 \
  tst-audit11 \
  tst-audit12 \
  tst-audit13 \
  tst-audit17 \
  tst-audit18 \
  tst-audit19b \
  tst-audit20 \
  tst-audit21 \
  tst-audit22 \
  tst-audit23 \
  tst-audit24a \
  tst-audit24b \
  tst-audit24c \
  tst-audit24d \
  tst-audit25a \
  tst-audit25b \
  tst-auditmany \
  tst-auxobj \
  tst-auxobj-dlopen \
  tst-big-note \
  tst-debug1 \
  tst-deep1 \
  tst-dl-is_dso \
  tst-dlmodcount \
  tst-dlmopen1 \
  tst-dlmopen3 \
  tst-dlmopen4 \
  tst-dlmopen-dlerror \
  tst-dlmopen-gethostbyname \
  tst-dlopenfail \
  tst-dlopenfail-2 \
  tst-dlopenrpath \
  tst-dlopen-self \
  tst-dlopen-tlsmodid \
  tst-dlsym-error \
  tst-filterobj \
  tst-filterobj-dlopen \
  tst-glibc-hwcaps \
  tst-glibc-hwcaps-mask \
  tst-glibc-hwcaps-prepend \
  tst-global1 \
  tst-global2 \
  tst-initfinilazyfail \
  tst-initorder \
  tst-initorder2 \
  tst-latepthread \
  tst-main1 \
  tst-nodelete2 \
  tst-nodelete-dlclose \
  tst-nodelete-opened \
  tst-noload \
  tst-null-argv \
  tst-p_align1 \
  tst-p_align2 \
  tst-p_align3 \
  tst-relsort1 \
  tst-ro-dynamic \
  tst-rtld-run-static \
  tst-single_threaded \
  tst-single_threaded-pthread \
  tst-sonamemove-dlopen \
  tst-sonamemove-link \
  tst-thrlock \
  tst-tls10 \
  tst-tls11 \
  tst-tls12 \
  tst-tls13 \
  tst-tls14 \
  tst-tls15 \
  tst-tls16 \
  tst-tls17 \
  tst-tls18 \
  tst-tls19 \
  tst-tls20 \
  tst-tls21 \
  tst-tls4 \
  tst-tls5 \
  tst-tlsalign \
  tst-tlsalign-extern \
  tst-tls-dlinfo \
  tst-tls-ie \
  tst-tls-ie-dlmopen \
  tst-tls-manydynamic \
  tst-unique1 \
  tst-unique2 \
  tst-unwind-ctor \
  tst-unwind-main \
  unload3 \
  unload4 \
  unload5 \
  unload6 \
  unload7 \
  unload8 \
  valgrind-test \
  # tests
tests-cxx = \
  tst-dlopen-nodelete-reloc \
  tst-nodelete \
  tst-unique3 \
  tst-unique4 \
  # tests-cxx

tests += $(if $(CXX),$(tests-cxx))

tests-internal += \
  circleload1 \
  loadtest \
  neededtest \
  neededtest2 \
  neededtest3 \
  neededtest4 \
  tst-audit19a \
  tst-create_format1 \
  tst-dl-hwcaps_split \
  tst-dl_find_object \
  tst-dl_find_object-threads \
  tst-dlmopen2 \
  tst-ptrguard1 \
  tst-stackguard1 \
  tst-tls-surplus \
  tst-tls3 \
  tst-tls6 \
  tst-tls7 \
  tst-tls8 \
  unload \
  unload2 \
  # tests-internal

tests-container += \
  tst-dlopen-self-container \
  tst-dlopen-tlsmodid-container \
  tst-pldd \
  tst-preload-pthread-libc \
  # tests-container

test-srcs = \
  tst-pathopt \
  # tests-srcs

ifeq (yes,$(have-fpie))
tests-pie += tst-align3
endif
selinux-enabled := $(shell cat /selinux/enforce 2> /dev/null)

ifneq ($(selinux-enabled),1)
tests-execstack-yes = \
  tst-execstack \
  tst-execstack-needed \
  tst-execstack-prog \
  # tests-execstack-yes
endif
ifeq ($(have-depaudit),yes)
tests += \
  tst-audit14 \
  tst-audit14a \
  tst-audit15 \
  tst-audit16 \
  # tests
ifeq ($(run-built-tests),yes)
tests-special += \
  $(objpfx)tst-audit14-cmp.out \
  $(objpfx)tst-audit14a-cmp.out \
  $(objpfx)tst-audit15-cmp.out \
  $(objpfx)tst-audit16-cmp.out \
  # tests-special
endif

=== .pc/lp1995362-elf-Fix-DFS-sorting-algorithm-for-LD_TRACE_LOADED_OB.patch/elf/Makefile ===
# Copyright (C) 1995-2022 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

# Makefile for elf subdirectory of GNU C Library.

subdir		:= elf

include ../Makeconfig

headers = \
  bits/elfclass.h \
  bits/link.h \
  bits/link_lavcurrent.h \
  elf.h \
  link.h \
  # headers

routines = \
  $(all-dl-routines) \
  dl-addr \
  dl-addr-obj \
  dl-error \
  dl-iteratephdr \
  dl-libc \
  dl-origin \
  dl-profstub \
  dl-reloc-static-pie \
  dl-support \
  dl-sym \
  dl-sysdep \
  enbl-secure \
  libc-dl_find_object \
  libc_early_init \
  rtld_static_init \
  # routines

# The core dynamic linking functions are in libc for the static and
# profiled libraries.
dl-routines = \
  dl-call-libc-early-init \
  dl-close \
  dl-debug \
  dl-debug-symbols \
  dl-deps \
  dl-exception \
  dl-execstack \
  dl-find_object \
  dl-fini \
  dl-init \
  dl-load \
  dl-lookup \
  dl-lookup-direct \
  dl-minimal-malloc \
  dl-misc \
  dl-object \
  dl-open \
  dl-origin \
  dl-printf \
  dl-profile \
  dl-reloc \
  dl-runtime \
  dl-scope \
  dl-setup_hash \
  dl-sort-maps \
  dl-thread_gscope_wait \
  dl-tls \
  dl-tls_init_tp \
  dl-trampoline \
  dl-version \
  dl-write \
  # dl-routines

ifeq (yes,$(use-ldconfig))
dl-routines += dl-cache
endif

ifneq (no,$(have-tunables))
dl-routines += dl-tunables
tunables-type = $(addprefix TUNABLES_FRONTEND_,$(have-tunables))
CPPFLAGS-dl-tunables.c += -DTUNABLES_FRONTEND=$(tunables-type)

ifeq (yesyes,$(build-shared)$(run-built-tests))
tests-special += $(objpfx)list-tunables.out
endif

# Make sure that the compiler does not insert any library calls in tunables
# code paths.
ifeq (yes,$(have-loop-to-function))
CFLAGS-dl-tunables.c += -fno-tree-loop-distribute-patterns
endif
endif

all-dl-routines = $(dl-routines) $(sysdep-dl-routines)
# But they are absent from the shared libc, because that code is in ld.so.
elide-routines.os = \
  $(all-dl-routines) \
  dl-exception \
  dl-origin \
  dl-reloc-static-pie \
  dl-support \
  dl-sysdep \
  enbl-secure \
  rtld_static_init \
  thread_gscope_wait \
  # elide-routines.os

# These object files are only included in the dynamically-linked libc.
shared-only-routines = libc-dl_find_object

# ld.so uses those routines, plus some special stuff for being the program
# interpreter and operating independent of libc.
rtld-routines = \
  $(all-dl-routines) \
  dl-audit \
  dl-compat \
  dl-conflict \
  dl-diagnostics \
  dl-diagnostics-cpu \
  dl-diagnostics-kernel \
  dl-environ \
  dl-error-minimal \
  dl-hwcaps \
  dl-hwcaps-subdirs \
  dl-hwcaps_split \
  dl-libc_freeres \
  dl-minimal \
  dl-mutex \
  dl-sysdep \
  dl-usage \
  rtld \
  # rtld-routines

all-rtld-routines = $(rtld-routines) $(sysdep-rtld-routines)

CFLAGS-dl-runtime.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-dl-lookup.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-dl-iteratephdr.c += $(uses-callbacks)

# Called during static library initialization, so turn stack-protection
# off for non-shared builds.
CFLAGS-dl-minimal-malloc.o = $(no-stack-protector)
CFLAGS-dl-minimal-malloc.op = $(no-stack-protector)

# On targets without __builtin_memset, rtld.c uses a hand-coded loop
# in _dl_start.  Make sure this isn't turned into a call to regular memset.
ifeq (yes,$(have-loop-to-function))
CFLAGS-rtld.c += -fno-tree-loop-distribute-patterns
endif

# Compile rtld itself without stack protection.
# Also compile all routines in the static library that are elided from
# the shared libc because they are in libc.a in the same way.

CFLAGS-.o += $(call elide-stack-protector,.o,$(elide-routines.os))
CFLAGS-.op += $(call elide-stack-protector,.op,$(elide-routines.os))
CFLAGS-.os += $(call elide-stack-protector,.os,$(all-rtld-routines))

# Add the requested compiler flags to the early startup code.
CFLAGS-dl-printf.os += $(rtld-early-cflags)
CFLAGS-dl-setup_hash.os += $(rtld-early-cflags)
CFLAGS-dl-sysdep.os += $(rtld-early-cflags)
CFLAGS-dl-tunables.os += $(rtld-early-cflags)
CFLAGS-dl-write.os += $(rtld-early-cflags)
CFLAGS-dl-writev.os += $(rtld-early-cflags)
CFLAGS-rtld.os += $(rtld-early-cflags)

ifeq ($(unwind-find-fde),yes)
routines += unwind-dw2-fde-glibc
shared-only-routines += unwind-dw2-fde-glibc
endif

before-compile  += $(objpfx)trusted-dirs.h
generated	+= trusted-dirs.h trusted-dirs.st for-renamed/renamed.so
generated-dirs	+= for-renamed

ifeq ($(build-shared),yes)
ld-map		= $(common-objpfx)ld.map
endif

ifeq (yes,$(build-shared))
extra-objs = \
  $(all-rtld-routines:%=%.os) \
  sofini.os \
  interp.os \
  # extra-objs
generated += \
  dl-allobjs.os \
  ld.so ldd \
  librtld.os \
  # generated
install-others	= $(inst_rtlddir)/$(rtld-installed-name) $(inst_bindir)/ld.so
install-bin-script = ldd
endif

others		= sprof sln
install-bin	= sprof
others-static   = sln
install-rootsbin = sln
sln-modules	:= static-stubs
extra-objs	+= $(sln-modules:=.o)

ifeq (yes,$(use-ldconfig))
ifeq (yes,$(build-shared))
others-static	+= ldconfig
others		+= ldconfig
install-rootsbin += ldconfig

ldconfig-modules := \
  cache \
  chroot_canon \
  readlib \
  static-stubs \
  stringtable \
  xmalloc \
  xstrdup \
  # ldconfig-modules
extra-objs	+= $(ldconfig-modules:=.o)
others-extras   = $(ldconfig-modules)
endif
endif

# To find xmalloc.c and xstrdup.c
vpath %.c ../locale/programs

ifeq ($(build-shared),yes)
extra-objs += sotruss-lib.os sotruss-lib.so
install-others += $(inst_auditdir)/sotruss-lib.so
install-bin-script += sotruss
generated += sotruss
libof-sotruss-lib = extramodules
LDFLAGS-sotruss-lib.so += $(z-now-$(bind-now))
$(objpfx)sotruss-lib.so: $(objpfx)sotruss-lib.os
	$(build-module-asneeded)
$(objpfx)sotruss-lib.so: $(common-objpfx)libc.so $(objpfx)ld.so \
	$(common-objpfx)libc_nonshared.a

$(objpfx)sotruss: sotruss.sh $(common-objpfx)config.make
	sed -e 's%@VERSION@%$(version)%g' \
	    -e 's%@TEXTDOMAINDIR@%$(localedir)%g' \
	    -e 's%@PREFIX@%$(prefix)%g' \
	    -e 's|@PKGVERSION@|$(PKGVERSION)|g' \
	    -e 's|@REPORT_BUGS_TO@|$(REPORT_BUGS_TO)|g' \
	    < $< > $@.new
	chmod 555 $@.new
	mv -f $@.new $@
$(inst_auditdir)/sotruss-lib.so: $(objpfx)sotruss-lib.so $(+force)
	$(do-install-program)
endif

tests-static-normal := \
  tst-array1-static \
  tst-array5-static \
  tst-dl-iter-static \
  tst-dst-static \
  tst-env-setuid \
  tst-env-setuid-tunables \
  tst-getauxval-static \
  tst-linkall-static \
  tst-single_threaded-pthread-static \
  tst-single_threaded-static \
  tst-tlsalign-extern-static \
  tst-tlsalign-static \
  # tests-static-normal

tests-static-internal := \
  tst-dl_find_object-static \
  tst-ptrguard1-static \
  tst-stackguard1-static \
  tst-tls1-static \
  tst-tls1-static-non-pie \
  # tests-static-internal

CRT-tst-tls1-static-non-pie := $(csu-objpfx)crt1.o
tst-tls1-static-non-pie-no-pie = yes

tests-container := \
  tst-ldconfig-bad-aux-cache \
  tst-ldconfig-ld_so_conf-update \
  # tests-container

ifeq (no,$(build-hardcoded-path-in-tests))
# This is an ld.so.cache test, and RPATH/RUNPATH in the executable
# interferes with its test objectives.
tests-container += tst-glibc-hwcaps-prepend-cache
endif

tests := \
  tst-array1 \
  tst-array2 \
  tst-array3 \
  tst-array4 \
  tst-array5 \
  tst-auxv \
  tst-leaks1 \
  tst-stringtable \
  tst-tls9 \
  # tests

tests-internal := \
  $(tests-static-internal) \
  tst-tls1 \
  # tests-internal

tests-static := $(tests-static-normal) $(tests-static-internal)

ifeq (yes,$(build-shared))
tests-static += \
  tst-single_threaded-static-dlopen \
  tst-tls9-static \
  # tests-static

static-dlopen-environment = \
  LD_LIBRARY_PATH=$(ld-library-path):$(common-objpfx)dlfcn
tst-tls9-static-ENV = $(static-dlopen-environment)
tst-single_threaded-static-dlopen-ENV = $(static-dlopen-environment)

tests += \
  argv0test \
  constload1 \
  dblload \
  dblunload \
  filter \
  global \
  initfirst \
  lateglobal \
  loadfail \
  multiload \
  next \
  nodelete \
  nodelete2 \
  nodlopen \
  nodlopen2 \
  noload \
  order \
  order2 \
  origtest \
  preloadtest \
  reldep \
  reldep2 \
  reldep3 \
  reldep4 \
  reldep5 \
  reldep6 \
  reldep7 \
  reldep8 \
  resolvfail \
  restest1 \
  restest2 \
  tst-absolute-sym \
  tst-absolute-zero \
  tst-addr1 \
  tst-align \
  tst-align2 \
  tst-align3 \
  tst-audit1 \
  tst-audit2 \
  tst-audit8 \
  tst-audit9 \
  tst-audit11 \
  tst-audit12 \
  tst-audit13 \
  tst-audit17 \
  tst-audit18 \
  tst-audit19b \
  tst-audit20 \
  tst-audit21 \
  tst-audit22 \
  tst-audit23 \
  tst-audit24a \
  tst-audit24b \
  tst-audit24c \
  tst-audit24d \
  tst-audit25a \
  tst-audit25b \
  tst-auditmany \
  tst-auxobj \
  tst-auxobj-dlopen \
  tst-big-note \
  tst-debug1 \
  tst-deep1 \
  tst-dl-is_dso \
  tst-dlmodcount \
  tst-dlmopen1 \
  tst-dlmopen3 \
  tst-dlmopen4 \
  tst-dlmopen-dlerror \
  tst-dlmopen-gethostbyname \
  tst-dlopenfail \
  tst-dlopenfail-2 \
  tst-dlopenrpath \
  tst-dlopen-self \
  tst-dlopen-tlsmodid \
  tst-dlsym-error \
  tst-filterobj \
  tst-filterobj-dlopen \
  tst-glibc-hwcaps \
  tst-glibc-hwcaps-mask \
  tst-glibc-hwcaps-prepend \
  tst-global1 \
  tst-global2 \
  tst-initfinilazyfail \
  tst-initorder \
  tst-initorder2 \
  tst-latepthread \
  tst-main1 \
  tst-nodelete2 \
  tst-nodelete-dlclose \
  tst-nodelete-opened \
  tst-noload \
  tst-null-argv \
  tst-p_align1 \
  tst-p_align2 \
  tst-p_align3 \
  tst-relsort1 \
  tst-ro-dynamic \
  tst-rtld-run-static \
  tst-single_threaded \
  tst-single_threaded-pthread \
  tst-sonamemove-dlopen \
  tst-sonamemove-link \
  tst-thrlock \
  tst-tls10 \
  tst-tls11 \
  tst-tls12 \
  tst-tls13 \
  tst-tls14 \
  tst-tls15 \
  tst-tls16 \
  tst-tls17 \
  tst-tls18 \
  tst-tls19 \
  tst-tls20 \
  tst-tls21 \
  tst-tls4 \
  tst-tls5 \
  tst-tlsalign \
  tst-tlsalign-extern \
  tst-tls-dlinfo \
  tst-tls-ie \
  tst-tls-ie-dlmopen \
  tst-tls-manydynamic \
  tst-unique1 \
  tst-unique2 \
  tst-unwind-ctor \
  tst-unwind-main \
  unload3 \
  unload4 \
  unload5 \
  unload6 \
  unload7 \
  unload8 \
  valgrind-test \
  # tests
tests-cxx = \
  tst-dlopen-nodelete-reloc \
  tst-nodelete \
  tst-unique3 \
  tst-unique4 \
  # tests-cxx

tests += $(if $(CXX),$(tests-cxx))

tests-internal += \
  circleload1 \
  loadtest \
  neededtest \
  neededtest2 \
  neededtest3 \
  neededtest4 \
  tst-audit19a \
  tst-create_format1 \
  tst-dl-hwcaps_split \
  tst-dl_find_object \
  tst-dl_find_object-threads \
  tst-dlmopen2 \
  tst-ptrguard1 \
  tst-stackguard1 \
  tst-tls-surplus \
  tst-tls3 \
  tst-tls6 \
  tst-tls7 \
  tst-tls8 \
  unload \
  unload2 \
  # tests-internal

tests-container += \
  tst-dlopen-self-container \
  tst-dlopen-tlsmodid-container \
  tst-pldd \
  tst-preload-pthread-libc \
  # tests-container

test-srcs = \
  tst-pathopt \
  # tests-srcs

ifeq (yes,$(have-fpie))
tests-pie += tst-align3
endif
selinux-enabled := $(shell cat /selinux/enforce 2> /dev/null)

ifneq ($(selinux-enabled),1)
tests-execstack-yes = \
  tst-execstack \
  tst-execstack-needed \
  tst-execstack-prog \
  # tests-execstack-yes
endif
ifeq ($(have-depaudit),yes)
tests += \
  tst-audit14 \
  tst-audit14a \
  tst-audit15 \
  tst-audit16 \
  # tests
ifeq ($(run-built-tests),yes)
tests-special += \
  $(objpfx)tst-audit14-cmp.out \
  $(objpfx)tst-audit14a-cmp.out \
  $(objpfx)tst-audit15-cmp.out \
  $(objpfx)tst-audit16-cmp.out \
  # tests-special
endif

=== fbtl/sysdeps/i386/Makefile ===
# Copyright (C) 2002-2013 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <http://www.gnu.org/licenses/>.

ifeq ($(subdir),csu)
gen-as-const-headers += tcb-offsets.sym
endif

ifeq ($(subdir),fbtl)
CFLAGS-pthread_create.c += -mpreferred-stack-boundary=4
CFLAGS-tst-align.c += -mpreferred-stack-boundary=4
CFLAGS-tst-align2.c += -mpreferred-stack-boundary=4
endif

=== debian/changelog ===
glibc (2.35-0ubuntu3.10+11.0trisquel1) aramo-security; urgency=medium

  * Rebuild as part of udeb repository for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sat, 14 Jun 2025 02:39:40 +0000

=== debian/control ===
Source: glibc
Section: libs
Priority: required
Build-Depends: gettext, dpkg (>= 1.18.7), dpkg-dev (>= 1.17.14), xz-utils, file, quilt,
 autoconf, gawk, debhelper (>= 10), rdfind, symlinks, netbase, gperf, bison,
 linux-libc-dev (>= 3.9) [linux-any], systemtap-sdt-dev [linux-any],
 libaudit-dev [linux-any], libcap-dev [linux-any], libselinux-dev [linux-any] <!stage2>,
 mig-for-host (>= 1.5-3) [hurd-i386], gnumach-dev (>= 2:1.8+git20200710-2~) [hurd-i386],
 hurd-dev (>= 1:0.9.git20201127-4~) [hurd-i386] | hurd-headers-dev [hurd-i386],
 kfreebsd-kernel-headers [kfreebsd-any],
 binutils (>= 2.29),
 g++-multilib [amd64 i386 kfreebsd-amd64 mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el powerpc ppc64 s390x sparc sparc64 x32] <!nobiarch>,
 python3:native,
 libidn2-0 (>= 2.0.5~) <!nocheck>,
 libc-bin (>= 2.35) <cross>,
 libgd-dev <!stage1> <!stage2>,
Build-Depends-Indep: perl, po-debconf (>= 1.0)
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
XSBC-Original-Maintainer: GNU Libc Maintainers <debian-glibc@lists.debian.org>
Uploaders: Clint Adams <clint@debian.org>, Aurelien Jarno <aurel32@debian.org>, Adam Conrad <adconrad@0c3.net>, Samuel Thibault <sthibault@debian.org>
Standards-Version: 4.2.1
Vcs-Browser: https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/glibc
Vcs-Git: https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/glibc
XSBC-Original-Vcs-Browser: https://salsa.debian.org/glibc-team/glibc
XSBC-Original-Vcs-Git: https://salsa.debian.org/glibc-team/glibc.git
Homepage: https://www.gnu.org/software/libc/libc.html

Package: libc-bin
Architecture: any
Section: libs
Priority: required
Essential: yes
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: manpages
Build-Profiles: <!stage1>
Description: GNU C Library: Binaries
 This package contains utility programs related to the GNU C Library.
 .
  * getconf: query system configuration variables
  * getent: get entries from administrative databases
  * iconv, iconvconfig: convert between character encodings
  * ldd, ldconfig: print/configure shared library dependencies
  * locale, localedef: show/generate locale definitions
  * tzselect, zdump, zic: select/dump/compile time zones

Package: libc-dev-bin
Architecture: any
Section: libdevel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: manpages, manpages-dev, libc-devtools (>> 2.35)
Build-Profiles: <!stage1>
Description: GNU C Library: Development binaries
 This package contains utility programs related to the GNU C Library
 development package.
 .
  * gencat: generate message catalogs
  * rpcgen: compile RPC protocols to C

Package: libc-devtools
Architecture: any
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libc-dev-bin (<< 2.31-8)
Replaces: libc-dev-bin (<< 2.31-8)
Recommends: manpages, manpages-dev
Build-Profiles: <!stage1> <!stage2>
Description: GNU C Library: Development tools
 This package contains development tools shipped by the GNU C
 Library.
 .
  * memusage, memusagestat: profile a program's memory usage
  * mtrace: interpret the malloc trace log
  * sotruss: trace shared library calls
  * sprof: display shared object profiling data

Package: libc-l10n
Architecture: all
Section: localization
Priority: standard
Multi-Arch: foreign
Depends: ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: localization files
 This package contains the translation files for the GNU C library and
 utility programs.

Package: glibc-doc
Architecture: all
Section: doc
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}, glibc-doc-reference (>= 2.18)
Build-Profiles: <!stage1>
Description: GNU C Library: Documentation
 Contains man pages for libpthread functions and the complete GNU C Library
 ChangeLog.  The GNU C Library Reference manual has been moved into
 glibc-doc-reference for licensing reasons.

Package: glibc-source
Architecture: all
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: xz-utils
Breaks: cross-toolchain-base (<< 45~), cross-toolchain-base-ports (<< 37~), cross-toolchain-base-mipsen (<< 10)
Build-Profiles: <!stage1>
Description: GNU C Library: sources
 This package contains the sources and patches which are needed to
 build glibc.

Package: locales
Architecture: all
Section: localization
Priority: standard
Depends: libc-bin (>> 2.35), ${misc:Depends}, debconf | debconf-2.0
Build-Profiles: <!stage1>
Description: GNU C Library: National Language (locale) data [support]
 Machine-readable data files, shared objects and programs used by the
 C library for localization (l10n) and internationalization (i18n) support.
 .
 This package contains tools to generate locale definitions from source
 files (included in this package). It allows you to customize which
 definitions actually get generated. This is a space-saver over how this
 package used to be, with all locales generated by default. This created
 a package that unpacked to an excess of 30 megs.

Package: locales-all
Architecture: any
Section: localization
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Precompiled locale data
 This package contains the precompiled locale data for all supported locales.
 A better alternative is to install the locales package and only select
 desired locales, but it can be useful on a low-memory machine because some
 locale files take a lot of memory to be compiled.

Package: nscd
Architecture: any
Section: admin
Multi-Arch: foreign
Priority: optional
Depends: lsb-base (>= 3.0-6), ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Name Service Cache Daemon
 A daemon which handles passwd, group and host lookups
 for running programs and caches the results for the next
 query. You should install this package only if you use
 slow services like LDAP, NIS or NIS+.

Package: libc6
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: libs
Priority: optional
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}, ${libcrypt:Depends}
Recommends: libidn2-0 (>= 2.0.5~), libnss-nis, libnss-nisplus
Suggests: glibc-doc, debconf | debconf-2.0, locales [!hurd-i386]
Provides: libc6-sparcv9b [sparc sparc64], libc0.1-i686 [kfreebsd-i386], libc0.3-i686 [hurd-i386], libc6-i686 [i386], libc6-xen [i386], libc6-armel [armel], libc6-armhf [armhf], libc6-lse [arm64]
Conflicts: libc0.1-i686 [kfreebsd-i386], libc6-i686 [i386], libc6-lse [arm64]
Breaks: nscd (<< 2.35), locales (<< 2.35), locales-all (<< 2.35), hurd (<< 1:0.9.git20170910-1), libtirpc1 (<< 0.2.3), r-cran-later (<< 0.7.5+dfsg-2), nocache (<< 1.1-1~), iraf-fitsutil (<< 2018.07.06-4), wcc (<< 0.0.2+dfsg-3), openssh-server (<< 1:8.2p1-4), macs (<< 2.2.7.1-3~), openarena (<< 0.8.8+dfsg-4~), ioquake3 (<< 1.36+u20200211.f2c61c1~dfsg-2~), libgegl-0.4-0 (<< 0.4.18), busybox (<< 1.30.1-6), libgegl-0.4-0 (<< 0.4.18), fakeroot (<< 1.25.3-1.1ubuntu2~)
Replaces: libc6-amd64 [amd64],
          libc6-i386 [i386],
          libc0.1-i686 [kfreebsd-i386],
          libc0.3-i686 [hurd-i386],
          libc6-i686 [i386],
          libc6-lse [arm64],
          libc6-xen [i386],
          libc6-x32 [x32],
          libc0.1-i386 [kfreebsd-i386],
          libc6-powerpc [powerpc],
          libc6-ppc64 [ppc64],
          libc6-s390x [s390x],
          libc6-sparc64 [sparc64],
          libc6-mips64 [mips64 mips64el],
          libc6-mipsn32 [mipsn32 mipsn32el],
          libc6-mips32 [mips mipsel],
          hurd (<< 20120408-3) [hurd-i386]
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.

Package: libc6-dev
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: libdevel
Priority: optional
Multi-Arch: same
Depends: libc6 (= ${binary:Version}) <!stage1>, libc-dev-bin (= ${binary:Version}), ${misc:Depends}, linux-libc-dev [linux-any], kfreebsd-kernel-headers (>= 0.11) [kfreebsd-any], gnumach-dev [hurd-i386], hurd-dev (>= 20080607-3) [hurd-i386] | hurd-headers-dev [hurd-i386], ${libcrypt-dev:Depends}, ${rpcsvc-proto:Depends}, ${libtirpc-dev:Depends}, ${libnsl-dev:Depends}
Replaces: hurd-dev (<< 20120408-3) [hurd-i386], kfreebsd-kernel-headers (<< 10.3~4) [kfreebsd-amd64 kfreebsd-i386]
Suggests: glibc-doc, manpages-dev
Provides: libc-dev, libc6-dev [alpha ia64 hurd-i386 kfreebsd-i386 kfreebsd-amd64], libc6-dev-armel [armel], libc6-dev-armhf [armhf]
Breaks: check (<< 0.9.10-6.1+b1) [s390x], kfreebsd-kernel-headers (<< 10.3~4) [kfreebsd-amd64 kfreebsd-i386], libperl5.26 (<< 5.26.1-3), ${libc-dev:Breaks}, python3.7 (<< 3.7.7-1+b1), python3.8 (<< 3.8.2-1+b1), libgcc-7-dev (<< 7.5.0-6~), libgcc-8-dev (<< 8.4.0-2~), libgcc-9-dev (<< 9.3.0-5~), libgcc-10-dev (<< 10-20200321-1~)
Conflicts: libc6.1-dev, libc0.1-dev, libc0.3-dev,
Description: GNU C Library: Development Libraries and Header Files
 Contains the symlinks, headers, and object files needed to compile
 and link programs which use the standard C library.

Package: libc6-dbg
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: debug
Priority: optional
Multi-Arch: same
Provides: libc-dbg, libc6-dbgsym
Depends: libc6 (= ${binary:Version}), ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: detached debugging symbols
 This package contains the detached debugging symbols for the GNU C
 library.

Package: libc6-udeb
Package-Type: udeb
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: debian-installer
Priority: optional
Depends: libcrypt1-udeb
Provides: libc6, libc-udeb, libnss-dns-udeb, libnss-files-udeb, ${locale-compat:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries - udeb
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.
 .
 This package contains a minimal set of libraries needed for the Debian
 installer.  Do not install it on a normal system.

Package: libc6.1
Architecture: alpha ia64
Section: libs
Priority: optional
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}, ${libcrypt:Depends}
Recommends: libidn2-0 (>= 2.0.5~), libnss-nis, libnss-nisplus
Suggests: glibc-doc, debconf | debconf-2.0, locales [!hurd-i386]
Provides: libc6-sparcv9b [sparc sparc64], libc0.1-i686 [kfreebsd-i386], libc0.3-i686 [hurd-i386], libc6-i686 [i386], libc6-xen [i386], libc6-armel [armel], libc6-armhf [armhf], libc6-lse [arm64]
Conflicts: libc0.1-i686 [kfreebsd-i386], libc6-i686 [i386], libc6-lse [arm64]
